import java.io.InputStream;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public abstract class Chr {
	public static final int FIXED_POINT = 12;
	public static final int GRAPHICS_HCENTER = 1;
	public static final int GRAPHICS_VCENTER = 2;
	public static final int GRAPHICS_LEFT = 4;
	public static final int GRAPHICS_RIGHT = 8;
	public static final int GRAPHICS_TOP = 16;
	public static final int GRAPHICS_BOTTOM = 32;
	public static final int GU_TRANS_NONE = 0;
	public static final int GU_TRANS_MIRROR_ROT180 = 1;
	public static final int GU_TRANS_MIRROR = 2;
	public static final int GU_TRANS_ROT180 = 3;
	public static final int GU_TRANS_MIRROR_ROT270 = 4;
	public static final int GU_TRANS_ROT90 = 5;
	public static final int GU_TRANS_ROT270 = 6;
	public static final int GU_TRANS_MIRROR_ROT90 = 7;
	public static final int CHRENEMY_NUM_MAX = 40;
	public static final int CHRBASE_NUM_MAX = 10;
	public static final int CHRBOSS_NUM_MAX = 54;
	public static final int[] DIR_X = new int[]{1, 0, -1, 0};
	public static final int[] DIR_Y = new int[]{0, -1, 0, 1};
	public static final int[] ANIME_3_LOOP = new int[]{0, 1, 2, 1};
	public static int[] SIN_TABLE;
	public static int[] COS_TABLE;
	public static Map map;
	public static int numActive;
	public static ChrOpaOpa chrOpaOpa;
	public static Chr[] chrEnemyActive;
	public static int numEnemyActive;
	public static int numBaseActive;
	public int worldX;
	public int worldY;
	public int worldVX;
	public int worldVY;
	public int screenX;
	public int screenY;
	public int collisionWidth;
	public int collisionHeight;
	public int collisionX1;
	public int collisionY1;
	public int collisionX2;
	public int collisionY2;
	public int dir;
	public int hp;
	public int score;
	public int money;
	public int count;
	public boolean isWorldView;
	public boolean isDead;
	public boolean needCheck;
	public int type;

	public static int mcrITOF(int x) {
		return x << 12;
	}

	public static int mcrFTOI(int x) {
		return x >> 12;
	}

	public static boolean mcrIsBetween(int a, int x, int b) {
		return a <= x && x <= b;
	}

	public static int mcrSQR(int x) {
		return x * x;
	}

	public static int getAngle(int x1, int y1, int x2, int y2) {
		long l_tx2 = (long) (x2 - x1);
		l_tx2 *= l_tx2;
		long l_ty2 = (long) (y2 - y1);
		l_ty2 *= l_ty2;
		if (l_tx2 + l_ty2 == 0L) {
			return 0;
		} else {
			int cos2t = (int) ((l_tx2 - l_ty2) * 4096L / (l_tx2 + l_ty2));
			int top = 0;
			int bottom = 128;

			do {
				if (cos2t >= COS_TABLE[top + bottom >> 1]) {
					bottom = top + bottom >> 1;
				} else {
					top = top + bottom >> 1;
				}
			} while (bottom - top >= 2);

			top >>= 1;
			if (x2 > x1) {
				if (y2 < y1) {
					top = 256 - top;
				}
			} else if (y2 < y1) {
				top += 128;
			} else {
				top = 128 - top;
			}

			return top;
		}
	}

	public static void clearNumActive() {
		numActive = 0;
	}

	public static int getNumActive() {
		return numActive;
	}

	public static void setActiveEnemy() {
		numEnemyActive = 0;
		numBaseActive = 0;

		int i;
		for (i = 9; i >= 0; --i) {
			if (ChrBase.chr[i].needCheck) {
				chrEnemyActive[numEnemyActive++] = ChrBase.chr[i];
				++numBaseActive;
			}
		}

		for (i = 39; i >= 0; --i) {
			if (ChrEnemy.chr[i].needCheck) {
				chrEnemyActive[numEnemyActive++] = ChrEnemy.chr[i];
			}
		}

		for (i = 53; i >= 0; --i) {
			if (ChrBoss.chr[i].needCheck) {
				chrEnemyActive[numEnemyActive++] = ChrBoss.chr[i];
			}
		}

	}

	public static void actActiveEnemy() {
		int i;
		for (i = numEnemyActive - 1; i >= 0; --i) {
			if (chrEnemyActive[i].needCheck) {
				chrEnemyActive[i].act();
			}
		}

		numActive += numEnemyActive;
		if (FantasyZone.gmStage % 8 != 7) {
			for (i = 9; i >= 0; --i) {
				if (!ChrBase.chr[i].needCheck) {
					ChrBase.chr[i].act();
				}
			}

		}
	}

	public static boolean isHitActiveEnemy() {
		for (int i = numEnemyActive - 1; i >= 0; --i) {
			if (chrOpaOpa.isHit(chrEnemyActive[i])) {
				if (chrEnemyActive[i] instanceof ChrBase) {
					chrEnemyActive[i].checkDie(255);
				}

				return true;
			}
		}

		return false;
	}

	public static void drawActiveEnemy() {
		int i;
		for (i = 9; i >= 0; --i) {
			if (!ChrBase.chr[i].needCheck) {
				ChrBase.chr[i].draw();
			}
		}

		for (i = numEnemyActive - 1; i >= 0; --i) {
			if (chrEnemyActive[i].needCheck) {
				chrEnemyActive[i].draw();
			}
		}

	}

	public void setCollision() {
		this.collisionX1 = this.screenX - this.collisionWidth;
		this.collisionY1 = this.screenY - this.collisionHeight;
		this.collisionX2 = this.screenX + this.collisionWidth;
		this.collisionY2 = this.screenY + this.collisionHeight;
	}

	public boolean isHit(Chr chr) {
		return chr.needCheck && this.collisionX1 <= chr.collisionX2 && this.collisionX2 >= chr.collisionX1
				&& this.collisionY1 <= chr.collisionY2 && this.collisionY2 >= chr.collisionY1
				&& chr.collisionWidth != 0;
	}

	public void drawCollision(Graphics gc, int color) {
		if (this.needCheck) {
			gc.setColor(color);
			gc.drawRect(mcrFTOI(this.collisionX1), mcrFTOI(this.collisionY1),
					mcrFTOI(this.collisionX2 - this.collisionX1) - 1, mcrFTOI(this.collisionY2 - this.collisionY1) - 1);
		}

	}

	public void drawRegion(Image img, int sx, int sy, int w, int h, int transform, int tx, int ty, int anchor) {
		GraphicsUtil.drawRegion2(FantasyZone.gcFrame.gc, img, sx, sy, w, h, transform, tx, ty, anchor);
	}

	public void checkDie(int damage) {
	}

	public abstract void act();

	public abstract void draw();

	static {
		try {
			InputStream is = Runtime.getRuntime().getClass().getResourceAsStream("/f1000");
			SIN_TABLE = new int[257];
			COS_TABLE = new int[257];
			byte[] buf = new byte[4];

			int i;
			for (i = 0; i < 256; ++i) {
				is.read(buf);
				SIN_TABLE[i] += ((buf[3] & 255) << 24) + ((buf[2] & 255) << 16) + ((buf[1] & 255) << 8)
						+ (buf[0] & 255);
			}

			for (i = 0; i < 256; ++i) {
				COS_TABLE[i] = SIN_TABLE[(-i + 64 + 256) % 256];
			}

			SIN_TABLE[256] = SIN_TABLE[0];
			COS_TABLE[256] = COS_TABLE[0];
			chrEnemyActive = new Chr[104];
		} catch (Exception var3) {
			;
		}

	}
}