import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public final class ChrBoss extends Chr {
	public static final int ENEMY_BOSS_STAGE7_PARAM_SRC_X = 0;
	public static final int ENEMY_BOSS_STAGE7_PARAM_SRC_Y = 1;
	public static final int ENEMY_BOSS_STAGE7_PARAM_WIDTH = 2;
	public static final int ENEMY_BOSS_STAGE7_PARAM_HEIGHT = 3;
	public static final int ENEMY_BOSS_STAGE7_PARAM_DST_X = 4;
	public static final int ENEMY_BOSS_STAGE7_PARAM_DST_Y = 5;
	public static final int ENEMY_BOSS_STAGE7_PARAM_MAX = 6;
	public static final int ENEMY_BOSS_SCORE = 10000;
	public static final int ENEMY_BOSS_LEVEL_MAX = 4;
	public static final int GU_TRANS_NONE = 0;
	public static final int GU_TRANS_MIRROR_ROT180 = 1;
	public static final int GU_TRANS_MIRROR = 2;
	public static final int GU_TRANS_ROT180 = 3;
	public static final int GU_TRANS_ROT90 = 5;
	public static final int GU_TRANS_ROT270 = 6;
	public static ChrBoss[] chr = new ChrBoss[54];
	public static int level;
	public static byte[][] MONEY = new byte[7][];
	public static byte[] BOSS2_TABLE;
	public static byte[] BOSS3_TABLE;
	public static byte[] BOSS5_TABLE;
	public static byte[] BOSS7_TABLE;
	public static boolean[] ALIEN_WAY = new boolean[775];
	public int type;
	public int hpMax;
	public boolean isNoDamage;

	public static void clearAll() {
		for (int i = 53; i >= 0; --i) {
			chr[i].needCheck = false;
		}

	}

	public static void create(int type, int stage) {
		int[] OFFSET = new int[]{0, 23, 58, 88, 139, 174, 205, 236, 242};
		level = (stage + 1) / 8;
		if (level > 4) {
			level = 4;
		}

		for (int i = 0; i < OFFSET[type + 1] - OFFSET[type]; ++i) {
			chr[i].reinit(OFFSET[type] + i, stage);
		}

	}

	public static void explode() {
		int i;
		int j;
		switch (map.boss) {
			case 0 :
				for (i = 1; i <= 20; ++i) {
					chr[i].isWorldView = true;
					chr[i].worldVX = mcrITOF((i % 4 * 2 - 3) * 2 + FantasyZone.rnd(6) - 3) >> 1;
					chr[i].worldVY = -mcrITOF(14 + FantasyZone.rnd(4) - 2) >> 1;
					chr[i].count = 0;
				}

				return;
			case 1 :
				i = 24;

				for (j = 1; i <= 49; ++j) {
					chr[j].isWorldView = true;
					chr[j].worldVX = mcrITOF((i % 4 * 2 - 3) * 2 + FantasyZone.rnd(6) - 3) >> 2;
					chr[j].worldVY = -mcrITOF(14 + FantasyZone.rnd(4) - 2) >> 1;
					chr[j].count = 0;
					++i;
				}

				return;
			case 2 :
				i = 68;

				for (j = 10; i <= 87; ++j) {
					chr[j].isWorldView = true;
					chr[j].worldVX = mcrITOF((i % 4 * 2 - 3) * 2 + FantasyZone.rnd(6) - 3) >> 2;
					chr[j].worldVY = -mcrITOF(14 + FantasyZone.rnd(4) - 2) >> 1;
					chr[j].count = 0;
					++i;
				}

				return;
			case 3 :
				i = 89;

				for (j = 1; i < 119; ++j) {
					chr[j].isWorldView = true;
					chr[j].worldVX = mcrITOF((i % 4 * 2 - 3) * 2 + FantasyZone.rnd(6) - 3) >> 2;
					chr[j].worldVY = -mcrITOF(14 + FantasyZone.rnd(4) - 2) >> 1;
					chr[j].count = 0;
					++i;
				}

				while (i <= 138) {
					chr[j].needCheck = false;
					++i;
					++j;
				}

				return;
			case 4 :
				i = 139;

				for (j = 0; i <= 154; ++j) {
					chr[j].needCheck = false;
					++i;
				}

				while (i <= 173) {
					chr[j].isWorldView = true;
					chr[j].worldVX = mcrITOF((i % 4 * 2 - 3) * 2 + FantasyZone.rnd(6) - 3) >> 1;
					chr[j].worldVY = -mcrITOF(14 + FantasyZone.rnd(4) - 2) >> 1;
					chr[j].count = 0;
					++i;
					++j;
				}

				return;
			case 5 :
				i = 175;

				for (j = 1; i <= 204; ++j) {
					chr[j].isWorldView = true;
					chr[j].worldVX = -COS_TABLE[chr[j].dir] * (8 + FantasyZone.rnd(2));
					chr[j].worldVY = -SIN_TABLE[chr[j].dir] * (8 + FantasyZone.rnd(2));
					chr[j].count = 0;
					++i;
				}

				return;
			case 6 :
				i = 206;

				for (j = 1; i <= 235; ++j) {
					chr[j].isWorldView = true;
					chr[j].worldVX = mcrITOF(BOSS7_TABLE[(chr[j].type - 206) * 6 + 4] + FantasyZone.rnd(4) - 2) >> 3;
					chr[j].worldVY = mcrITOF(-1) * (4 + FantasyZone.rnd(2));
					chr[j].count = 0;
					++i;
				}
		}

	}

	public static void drawAllCollision(Graphics gc, int color) {
		for (int i = 53; i >= 0; --i) {
			chr[i].drawCollision(gc, color);
		}

	}

	private void reinit(int type, int stage) {
		this.screenX = chr[0].screenX;
		this.screenY = chr[0].screenY;
		this.worldVX = 0;
		this.worldVY = 0;
		this.collisionWidth = 0;
		this.collisionHeight = 0;
		this.dir = 0;
		this.hp = 0;
		this.score = 0;
		this.money = 0;
		this.isWorldView = false;
		this.count = 0;
		this.isDead = false;
		this.needCheck = true;
		this.type = type;
		this.isNoDamage = true;
		this.hpMax = 0;
		if (type == 0) {
			this.screenX = mcrITOF(173);
			this.screenY = mcrITOF(-120);
			this.worldVY = mcrITOF(4);
			this.collisionWidth = mcrITOF(4);
			this.collisionHeight = mcrITOF(5);
			this.dir = 3;
			this.hp = 20;
			this.score = 10000;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(1, type, 20)) {
			this.screenX = chr[0].screenX + mcrITOF(5) + mcrITOF(16 * ((type - 1) % 4));
			this.screenY = chr[0].screenY - mcrITOF(36) + mcrITOF(17 * ((type - 1) / 4));
			this.collisionWidth = mcrITOF(6);
			this.collisionHeight = mcrITOF(8);
			this.money = MONEY[0][type - 1];
		}

		if (mcrIsBetween(21, type, 22)) {
			this.collisionWidth = mcrITOF(5);
			this.collisionHeight = mcrITOF(3);
		}

		if (type == 23) {
			this.screenX = mcrITOF(188);
			this.screenY = mcrITOF(320);
			this.worldVY = -mcrITOF(4);
			this.dir = 1;
			this.score = 10000;
		}

		if (mcrIsBetween(50, type, 57)) {
			this.hp = 10;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(42, type, 49)) {
			this.money = MONEY[1][type - 24];
		}

		if (mcrIsBetween(24, type, 41)) {
			this.collisionWidth = mcrITOF(8);
			this.collisionHeight = mcrITOF(8);
			this.dir = type < 33 ? 2 : 0;
			this.money = MONEY[1][type - 24];
		}

		if (type == 58) {
			this.screenX = mcrITOF(240 + (map.stage % 8 == 7 ? 35 : 60));
			this.screenY = mcrITOF(100);
			this.score = 10000;
		}

		if (mcrIsBetween(59, type, 67)) {
			this.worldVX = 0;
			this.worldVY = 0;
			this.collisionWidth = mcrITOF(12);
			this.collisionHeight = mcrITOF(4);
			this.dir = 0;
			this.hp = 36;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(68, type, 87)) {
			if ((type - 68) / 4 != 0 && (type - 68) / 4 != 4 && type != 72 && type != 80) {
				this.collisionWidth = mcrITOF(3);
				this.collisionHeight = mcrITOF(9);
			} else {
				this.collisionWidth = 0;
				this.collisionHeight = 0;
			}

			this.money = MONEY[2][type - 68];
		}

		if (type == 88) {
			this.screenX = mcrITOF(288 + level * 6);
			this.screenY = mcrITOF(100);
			this.worldVX = mcrITOF(-2);
			this.collisionWidth = mcrITOF(32);
			this.collisionHeight = mcrITOF(38);
			this.score = 10000;
		}

		if (mcrIsBetween(119, type, 138)) {
			this.worldVX = 0;
			this.worldVY = 0;
			this.collisionWidth = mcrITOF(9);
			this.collisionHeight = mcrITOF(9);
			this.dir = type < 129 ? 1 : 3;
			this.hp = 6;
			this.money = 0;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(89, type, 118)) {
			this.dir = (type - 89) % 6 < 3 ? 2 : 0;
			this.money = MONEY[3][type - 89];
		}

		if (mcrIsBetween(139, type, 153)) {
			this.dir = 0;
			if (type >= 140) {
				++this.dir;
			}

			if (type >= 142) {
				++this.dir;
			}

			if (type >= 146) {
				++this.dir;
			}

			this.screenX = mcrITOF(360 + BOSS5_TABLE[(type - 139) * 2 + 0]);
			this.screenY = mcrITOF(100 + BOSS5_TABLE[(type - 139) * 2 + 1]);
			this.worldVX = mcrITOF(-1) >> 1;
			this.collisionWidth = mcrITOF(48 / (1 << this.dir + 1));
			this.collisionHeight = mcrITOF(64 / (1 << this.dir + 1));
			this.hp = 32 / (1 << (this.dir >= 2 ? this.dir + 1 : this.dir));
			this.score = type == 139 ? 10000 : 0;
			this.isNoDamage = type < 146;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(154, type, 173)) {
			this.money = MONEY[4][type - 154];
		}

		if (type == 174) {
			this.screenX = mcrITOF(-80);
			this.screenY = mcrITOF(90);
			this.worldVX = mcrITOF(4);
			this.collisionWidth = mcrITOF(8);
			this.collisionHeight = mcrITOF(8);
			this.dir = 0;
			this.hp = 12;
			this.score = 10000;
			this.money = 0;
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(175, type, 204)) {
			this.collisionWidth = mcrITOF(7);
			this.collisionHeight = mcrITOF(10);
			this.dir = (256 * ((type - 175) / 5) / 6 + 64) % 256;
			this.money = MONEY[5][type - 175];
		}

		if (type == 205) {
			this.screenX = chrOpaOpa.screenX;
			this.screenY = chrOpaOpa.screenY;
			this.dir = 0;
			this.hp = 72;
			this.score = 10000;
			this.needCheck = true;
			this.type = type;
			this.isNoDamage = true;
			this.hpMax = this.hp;
			level <<= 1;
		}

		if (mcrIsBetween(206, type, 235)) {
			this.collisionWidth = -mcrITOF(240);
			this.dir = BOSS7_TABLE[(type - 206) * 6 + 4] >= 0 ? 0 : 2;
			this.money = MONEY[6][type - 206];
			this.hpMax = this.hp;
		}

		if (mcrIsBetween(236, type, 241)) {
			if (type == 241) {
				level = type - 236;
				reinitAlien(false);
			}

			this.screenX = mcrITOF(256);
			this.screenY = mcrITOF(88);
			this.collisionWidth = mcrITOF(8);
			this.collisionHeight = mcrITOF(8);
			this.dir = 2;
			this.hp = 26 - (type - 236) * 3;
			this.isNoDamage = type != 241;
			this.hpMax = this.hp;
		}

		this.worldX = map.getWorldX(this.screenX);
		this.worldY = map.getWorldY(this.screenY);
		this.collisionX1 = this.screenX - this.collisionWidth;
		this.collisionY1 = this.screenY - this.collisionHeight;
		this.collisionX2 = this.screenX + this.collisionWidth;
		this.collisionY2 = this.screenY + this.collisionHeight;
	}

	public void act() {
		++this.count;
		int tmpCount;
		if (this.type == 0) {
			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
			if (this.count >= 50) {
				tmpCount = (this.count - 50) % 72;
				if (this.count >= 842) {
					this.worldVX = (chrOpaOpa.screenX < chr[0].screenX ? -1 : 2)
							* (mcrITOF(1) * (this.count - 842) / 200);
				}

				this.worldVY += DIR_Y[this.dir] * (mcrITOF(1) >> 1);
				if (this.dir == 3) {
					if ((this.screenY > chrOpaOpa.screenY || this.screenY > mcrITOF(120)) && this.worldVY >= mcrITOF(5)
							|| this.worldVY >= mcrITOF(7)) {
						this.dir = 1;
					}
				} else if ((this.screenY < chrOpaOpa.screenY || this.screenY < mcrITOF(80))
						&& this.worldVY <= -mcrITOF(5) || this.worldVY <= -mcrITOF(7)) {
					this.dir = 3;
				}

				if (mcrIsBetween(30, tmpCount, 41) || mcrIsBetween(54, tmpCount, 71)) {
					ChrEnemyShot.create(6, this.worldX, this.worldY, this.worldX - mcrITOF(20),
							this.worldY + mcrITOF(FantasyZone.rnd(149) - 70) / 10);
				}

				this.isNoDamage = !mcrIsBetween(30, tmpCount, 41) && !mcrIsBetween(54, tmpCount, 71);
			}
		}

		if (mcrIsBetween(1, this.type, 20)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				this.screenX = chr[0].screenX + mcrITOF(5) + mcrITOF(16 * ((this.type - 1) % 4));
				this.screenY = chr[0].screenY - mcrITOF(36) + mcrITOF(17 * ((this.type - 1) / 4));
			}
		}

		if (this.type == 21) {
			this.screenX = chr[0].screenX;
			this.screenY = chr[0].screenY - mcrITOF(10);
		}

		if (this.type == 22) {
			this.screenX = chr[0].screenX;
			this.screenY = chr[0].screenY + mcrITOF(10);
		}

		int i;
		if (this.type == 23) {
			if (this.count == 60) {
				this.worldVY = 0;
			}

			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
			if (this.count >= 1350) {
				this.worldVX = (chrOpaOpa.screenX < chr[0].screenX ? -1 : 1) * (mcrITOF(1) * (this.count - 1350) / 200);
				this.worldVY = (chrOpaOpa.screenY < chr[0].screenY ? -1 : 1) * (mcrITOF(1) * (this.count - 1350) / 200);
			} else if (this.count >= 120 && this.count % 60 < 6) {
				ChrEnemyShot.create(7, this.worldX, this.worldY - mcrITOF(40),
						map.getWorldX(mcrITOF(FantasyZone.rnd(224) + 8)), map.getWorldY(mcrITOF(-40)));
				ChrEnemyShot.create(7, this.worldX, this.worldY - mcrITOF(44),
						map.getWorldX(mcrITOF(FantasyZone.rnd(224) + 8)), map.getWorldY(mcrITOF(-40)));
			}

			for (i = 50; i <= 57 && !chr[i - 23].needCheck; ++i) {
				;
			}

			if (i > 57) {
				this.dead();
			}
		}

		if (mcrIsBetween(42, this.type, 49)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = ((this.type - 42) * 256 / 8 + this.count * 5) % 256;
				if (this.count < 80) {
					this.screenX = chr[0].screenX + SIN_TABLE[tmpCount] * (40 + 10 * (80 - this.count));
					this.screenY = chr[0].screenY + COS_TABLE[tmpCount] * (40 + 10 * (80 - this.count));
				} else {
					this.screenX = chr[0].screenX + SIN_TABLE[tmpCount] * 40;
					this.screenY = chr[0].screenY + COS_TABLE[tmpCount] * 40;
					this.collisionWidth = mcrITOF(9);
					this.collisionHeight = mcrITOF(9);
				}
			}
		}

		if (mcrIsBetween(50, this.type, 57)) {
			tmpCount = 256 - ((this.type - 50) * 256 / 8 + this.count * 15) % 256;
			if (this.count < 100) {
				this.screenX = chr[0].screenX + SIN_TABLE[tmpCount] * (30 + 10 * (100 - this.count));
				this.screenY = chr[0].screenY + COS_TABLE[tmpCount] * (30 + 10 * (100 - this.count));
			} else {
				this.screenX = chr[0].screenX + SIN_TABLE[tmpCount] * 30;
				this.screenY = chr[0].screenY + COS_TABLE[tmpCount] * 30;
				this.collisionWidth = mcrITOF(8);
				this.collisionHeight = mcrITOF(8);
				this.isNoDamage = false;
			}
		}

		if (mcrIsBetween(24, this.type, 41)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = (this.type - 24) % 9;
				this.screenX = chr[0].screenX + mcrITOF(BOSS2_TABLE[6 * tmpCount + 4]) * DIR_X[this.dir];
				this.screenY = chr[0].screenY + mcrITOF(BOSS2_TABLE[6 * tmpCount + 5]);
			}
		}

		if (this.type == 58) {
			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
			if (this.count < 25) {
				this.worldVX = mcrITOF(-4);
				this.worldVY = 0;
			}

			if (this.count == 25) {
				this.worldVX = 0;
				this.worldVY = mcrITOF(5) >> 3;
			}

			if (this.count >= 1350) {
				this.worldVX = (chrOpaOpa.screenX < chr[0].screenX ? -1 : 1) * (mcrITOF(1) * (this.count - 1350) / 200);
			}

			if (this.screenY < mcrITOF(45) || this.screenY > mcrITOF(148)) {
				this.worldVY = -this.worldVY;
			}

			for (i = 59; i <= 67 && !chr[i - 58].needCheck; ++i) {
				;
			}

			if (i > 67) {
				this.dead();
			}
		}

		if (mcrIsBetween(59, this.type, 67)) {
			this.isNoDamage = this.count <= 25;
			if (!this.isNoDamage) {
				if (this.count % 10 == 0) {
					this.count += level;
				}

				tmpCount = (this.count - 35) / 10 % 16;
				if (tmpCount >= 9) {
					tmpCount = 16 - tmpCount;
				}

				if (this.dir != 0 || this.type - 59 == tmpCount && (this.count - 35) % 10 < 5) {
					this.dir = (this.dir + 1) % 8;
					if (this.dir == 3) {
						this.worldVX = this.screenX;
						this.worldVY = this.screenY;
					}

					if (mcrIsBetween(3, this.dir, 6)) {
						ChrEnemyShot.create(8, map.getWorldX(this.worldVX), map.getWorldY(this.worldVY),
								map.getWorldX(this.worldVX) - 1, map.getWorldY(this.worldVY));
					}
				}
			}

			tmpCount = this.type - 59;
			this.screenX = chr[0].screenX + mcrITOF(BOSS3_TABLE[tmpCount * 2 + 0])
					- mcrITOF((this.dir < 4 ? this.dir : 8 - this.dir) * 2);
			this.screenY = chr[0].screenY + mcrITOF(BOSS3_TABLE[tmpCount * 2 + 1]);
		}

		if (mcrIsBetween(68, this.type, 87)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = this.type - 68;
				this.screenX = chr[0].screenX + mcrITOF(16) * (tmpCount % 4) - mcrITOF(24);
				this.screenY = chr[0].screenY + mcrITOF(17) * (tmpCount / 4) - mcrITOF(34);
			}
		}

		if (this.type == 88) {
			if (this.count == 48) {
				this.worldVX = 0;
			}

			if (this.count == 112) {
				this.worldVY = mcrITOF(1) >> 3;
			}

			if (this.screenY < mcrITOF(80) || this.screenY > mcrITOF(120)) {
				this.worldVY = -this.worldVY;
			}

			if (this.count >= 1350) {
				this.worldVX = (chrOpaOpa.screenX < chr[0].screenX ? -1 : 1) * (mcrITOF(1) * (this.count - 1350) / 200);
			}

			this.screenX += this.worldVX;
			this.screenY += this.worldVY;

			for (i = 119; i <= 138 && chr[i - 88].hp <= 0; ++i) {
				;
			}

			if (i > 138) {
				this.dead();
			}
		}

		if (this.type == 119 || this.type == 129) {
			this.screenX = chr[0].screenX;
			this.screenY = chr[0].screenY + DIR_Y[this.dir] * mcrITOF(48);
			if (this.count == 48) {
				this.worldVY = 12;
			}

			this.worldVX += this.worldVY;
			if (this.worldVX * DIR_Y[this.dir] > 80) {
				if (FantasyZone.rnd(2) == 0) {
					this.worldVY = -(FantasyZone.rnd(8) + 5) * DIR_Y[this.dir];
				} else {
					this.worldVY = -this.worldVY;
				}
			}

			if (this.worldVX * DIR_Y[this.dir] < -80) {
				this.worldVY = -this.worldVY;
			}

			if (this.count == 112) {
				this.isNoDamage = false;
			}
		}

		if (mcrIsBetween(120, this.type, 128) || mcrIsBetween(130, this.type, 138)) {
			tmpCount = this.type - 88 - 1;
			this.worldVX = this.worldVY;
			this.worldVY = this.money;
			this.money = chr[tmpCount].worldVX;
			if (this.count < 48) {
				this.screenX = chr[tmpCount].screenX;
				this.screenY = chr[tmpCount].screenY;
			} else if (this.count < 112) {
				this.screenX = chr[tmpCount].screenX + COS_TABLE[(this.worldVX + 128) % 256] * (this.count - 48 >> 2);
				this.screenY = chr[tmpCount].screenY + SIN_TABLE[(this.worldVX + 128) % 256] * (this.count - 48 >> 2);
			} else {
				this.screenX = chr[tmpCount].screenX + COS_TABLE[(this.worldVX + 128) % 256] * 16;
				this.screenY = chr[tmpCount].screenY + SIN_TABLE[(this.worldVX + 128) % 256] * 16;
			}

			if ((this.type == 128 || this.type == 138)
					&& (this.count % (20 / (level + 1)) == 0 || this.worldVX * this.worldVY < 0) && this.count >= 128
					&& mcrIsBetween(0, this.screenY, mcrITOF(200))) {
				ChrEnemyShot.create(9, this.worldX, this.worldY, chrOpaOpa.worldX, chrOpaOpa.worldY);
			}

			if (this.count == 112) {
				this.isNoDamage = false;
			}
		}

		if (mcrIsBetween(89, this.type, 118)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = this.type - 89;
				this.screenX = chr[0].screenX + mcrITOF(16 * (tmpCount % 6) - 40);
				this.screenY = chr[0].screenY + mcrITOF(15 * (tmpCount / 6) - 30);
			}
		}

		if (this.type == 139) {
			if (this.count == 330) {
				this.worldVX = 0;
			}

			if (this.count > 720) {
				this.worldVX = (chrOpaOpa.screenX < this.screenX ? -1 : 1) * (mcrITOF(1) * (this.count - 600) / 200);
				this.worldVY = (chrOpaOpa.screenY < this.screenY ? -1 : 1) * (mcrITOF(1) * (this.count - 600) / 200);
				this.isNoDamage = false;
			} else if (!this.isNoDamage) {
				this.worldVY = ((this.type - 139 & 1) - 2) * COS_TABLE[(this.count - 1) % 24 * 256 / 24]
						* (4 - this.dir) + (chrOpaOpa.screenY > this.screenY ? mcrITOF(1) : mcrITOF(-1));
				tmpCount = 4 - (level >> 1);
				if (this.count % tmpCount == 0 && this.count % (tmpCount << 3) != 0) {
					ChrEnemyShot.create(13 - this.dir, this.worldX, this.worldY, chrOpaOpa.worldX,
							chrOpaOpa.worldY + mcrITOF(FantasyZone.rnd(63) - 31));
				}
			} else {
				this.isNoDamage = chr[1].needCheck || chr[2].needCheck;
			}

			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
		}

		if (mcrIsBetween(140, this.type, 153)) {
			this.worldVY = ((this.type - 139 & 1) * 2 - 1) * COS_TABLE[(this.count - 1) % 24 * 256 / 24]
					* (4 - this.dir);
			if (this.count == 330) {
				this.worldVX = 0;
			}

			if (this.count > 720) {
				this.worldVX = (chrOpaOpa.screenX < this.screenX ? -1 : 1) * (mcrITOF(1) * (this.count - 600) / 200);
				this.worldVY = (chrOpaOpa.screenY < this.screenY ? -1 : 1) * (mcrITOF(1) * (this.count - 600) / 200);
				this.isNoDamage = false;
			} else if (!this.isNoDamage
					|| !chr[(this.type - 139) * 2 + 1].needCheck && !chr[(this.type - 139) * 2 + 2].needCheck) {
				tmpCount = 8 - (level >> 1);
				if (this.count % tmpCount == 0 && this.count % (tmpCount * (5 - this.dir)) != 0) {
					ChrEnemyShot.create(13 - this.dir, this.worldX, this.worldY, chrOpaOpa.worldX,
							chrOpaOpa.worldY + mcrITOF(FantasyZone.rnd(63) - 31));
				}
			}

			if (this.isNoDamage) {
				this.isNoDamage = false;

				for (i = (1 << this.dir + 1) - 1; i < (1 << this.dir + 2) - 1; ++i) {
					this.isNoDamage |= chr[i].needCheck;
				}
			}

			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
		}

		if (mcrIsBetween(154, this.type, 173)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = this.type - 154;
				this.screenX = chr[0].screenX + mcrITOF(14 * (tmpCount % 4) - 21);
				this.screenY = chr[0].screenY + mcrITOF(15 * (tmpCount / 4) - 30);
			}
		}

		if (this.type == 174) {
			if (this.count <= 50) {
				this.screenX += this.worldVX;
			} else if (this.count >= 85) {
				if (++this.dir >= 5) {
					this.isNoDamage = false;
				}

				if (++this.money == 256) {
					if (++level > 4) {
						level = 4;
					}

					this.money = 0;
				}
			}
		}

		if (mcrIsBetween(175, this.type, 204)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = (this.type - 175) % 5 * 28 + 28;
				if (this.count < 70) {
					tmpCount += 70 - this.count << 4;
				} else if (this.count >= 90 && this.count % 4 != 0) {
					this.dir = (this.dir + 1 + level / 2 + (level & this.count & 1)) % 256;
				}

				this.screenX = chr[0].screenX + COS_TABLE[this.dir] * tmpCount;
				this.screenY = chr[0].screenY + SIN_TABLE[this.dir] * tmpCount;
			}
		}

		if (this.type == 205) {
			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
			switch (this.dir) {
				case 0 :
					if (this.count == 26 - level) {
						this.worldVX = 0;
						this.worldVY = 0;
						this.dir = 1;
						this.count = 0;
					}
					break;
				case 1 :
					this.collisionWidth = mcrITOF(56);
					this.collisionHeight = mcrITOF(44);
					if (this.count > 10 - (level >> 2)) {
						this.collisionWidth = 0;
						this.collisionHeight = 0;
						this.dir = 2;
						this.count = 0;
					}
					break;
				case 2 :
					if (this.count > 10 - (level >> 2)) {
						if (level < 20) {
							++level;
						}

						this.worldVX = (chrOpaOpa.screenX - this.screenX) / (26 - level);
						this.worldVY = (chrOpaOpa.screenY - this.screenY) / (26 - level);
						this.dir = 0;
						this.count = 0;
					}
			}

			this.isNoDamage = this.dir != 1;
		}

		if (mcrIsBetween(206, this.type, 235)) {
			if (this.isWorldView) {
				this.actExplode();
			} else {
				tmpCount = (this.type - 206) * 6;
				if (chr[0].dir == 0) {
					this.screenX = chr[0].screenX
							+ mcrITOF(BOSS7_TABLE[tmpCount + 4]) * (39 - 26 * chr[0].count / (26 - level)) / 13;
					this.screenY = chr[0].screenY
							+ mcrITOF(BOSS7_TABLE[tmpCount + 5]) * (39 - 26 * chr[0].count / (26 - level)) / 13;
				} else if (chr[0].dir == 1) {
					this.screenX = chr[0].screenX + mcrITOF(BOSS7_TABLE[tmpCount + 4]);
					this.screenY = chr[0].screenY + mcrITOF(BOSS7_TABLE[tmpCount + 5]);
				} else {
					this.screenX = chr[0].screenX
							+ mcrITOF(BOSS7_TABLE[tmpCount + 4]) * (5 + 10 * chr[0].count / (10 - (level >> 2))) / 5;
					this.screenY = chr[0].screenY
							+ mcrITOF(BOSS7_TABLE[tmpCount + 5]) * (5 + 10 * chr[0].count / (10 - (level >> 2))) / 5;
				}
			}
		}

		if (mcrIsBetween(236, this.type, 241)) {
			Map var10000;
			Map var10001;
			Graphics var4;
			if (this.screenX > mcrITOF(240)) {
				if (!chr[this.type - 236 + 1].needCheck) {
					this.screenX -= mcrITOF(4);
					var10000 = map;
					var4 = Map.imgBackground[0].getGraphics();
					var10001 = map;
					GraphicsUtil.drawRegion(var4, Map.imgBaseBoss[7], 48, 0, 8, 8, 0, mcrFTOI(this.screenX),
							mcrFTOI(this.screenY), 3);
				}
			} else {
				this.isNoDamage = false;
				if (this.count > 0) {
					for (i = 1; i >= 0; --i) {
						tmpCount = mcrITOF(8) >> (this.type - 236) / 2;
						this.screenX += DIR_X[this.dir] * tmpCount;
						this.screenY += DIR_Y[this.dir] * tmpCount;
						if (this.screenX % mcrITOF(8) == 0 && this.screenY % mcrITOF(8) == 0) {
							tmpCount = this.dir;
							this.worldVX = mcrFTOI(this.screenX) / 8;
							this.worldVY = mcrFTOI(this.screenY) / 8;
							if (this.type == 236) {
								if (DIR_X[this.dir] != 0) {
									if ((this.screenX - chrOpaOpa.screenX) * DIR_X[this.dir] > 0
											|| ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
													+ DIR_X[this.dir]]) {
										this.dir = this.screenY > chrOpaOpa.screenY ? 1 : 3;
									}
								} else if ((this.screenY - chrOpaOpa.screenY) * DIR_Y[this.dir] > 0
										|| ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
												+ DIR_X[this.dir]]) {
									this.dir = this.screenX > chrOpaOpa.screenX ? 2 : 0;
								}
							}

							if (this.type == 237) {
								if (DIR_X[this.dir] != 0) {
									if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
											+ DIR_X[this.dir]]) {
										this.dir = this.screenY > chrOpaOpa.screenY ? 1 : 3;
									}
								} else if ((this.screenY - chrOpaOpa.screenY) * DIR_Y[this.dir] >= 0
										|| ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
												+ DIR_X[this.dir]]) {
									this.dir = this.screenX > chrOpaOpa.screenX ? 2 : 0;
								}
							}

							if (this.type == 238) {
								if (this.money == 0) {
									this.dir = 1;
								} else if (mcrIsBetween(8, this.money, 183)) {
									switch ((this.money - 8) % 44) {
										case 0 :
										case 22 :
											this.dir = 2;
											break;
										case 3 :
											this.dir = 3;
											break;
										case 25 :
											this.dir = 1;
									}
								} else if (mcrIsBetween(184, this.money, 223)) {
									switch (this.money - 184) {
										case 0 :
										case 20 :
											this.dir = 2;
											break;
										case 1 :
											this.dir = 3;
											break;
										case 21 :
											this.dir = 1;
									}
								} else if (mcrIsBetween(224, this.money, 266)) {
									switch (this.money - 224) {
										case 1 :
										case 23 :
											this.dir = 0;
											break;
										case 4 :
											this.dir = 3;
											break;
										case 24 :
											this.dir = 1;
									}
								} else if (this.money < 403) {
									switch ((this.money - 266) % 44) {
										case 1 :
										case 25 :
											this.dir = 0;
											break;
										case 6 :
											this.dir = 3;
											break;
										case 26 :
											this.dir = 1;
									}
								} else if (this.money < 404) {
									this.dir = 1;
								} else if (this.money < 431) {
									this.dir = 2;
								} else if (this.money < 453) {
									this.dir = 3;
								} else if (this.money < 460) {
									this.dir = 0;
								} else if (this.money < 461) {
									this.dir = 1;
								} else {
									if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
											+ DIR_X[this.dir]]) {
										this.dir = DIR_X[this.dir] == 0 ? 0 : 1;
									}

									if (!ALIEN_WAY[(this.worldVY - 1) * 31 + this.worldVX]) {
										this.dir = 1;
									}
								}

								++this.money;
							}

							if (this.type == 239) {
								if (this.money % 3 == 0) {
									this.dir = this.money % 6 == 0 ? 1 : 0;
									++this.money;
								} else if ((this.money & 1) == 0) {
									if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
											+ DIR_X[this.dir]]) {
										this.dir = 1;
										++this.money;
									}
								} else if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
										+ DIR_X[this.dir]]) {
									this.dir = 2;
									++this.money;
								}
							}

							if (this.type == 240) {
								if (this.money % 6 == 0) {
									this.dir = this.money % 12 == 0 ? 1 : 3;
									++this.money;
								} else if ((this.money & 1) == 0) {
									if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
											+ DIR_X[this.dir]]) {
										this.dir = 1;
										++this.money;
									}
								} else if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
										+ DIR_X[this.dir]]) {
									this.dir = 2;
									++this.money;
								}
							}

							if (this.type == 241) {
								if ((this.money & 1) == 0) {
									this.dir = 1;
									++this.money;
								} else if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
										+ DIR_X[this.dir]]) {
									this.dir = 2;
									++this.money;
								}
							}

							ALIEN_WAY[this.worldVY * 31 + this.worldVX] = true;
							if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX + DIR_X[this.dir]]) {
								this.dir = (this.dir + 2) % 4;
								if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX + DIR_X[this.dir]]) {
									this.dir = tmpCount;
									if (ALIEN_WAY[(this.worldVY + DIR_Y[this.dir]) * 31 + this.worldVX
											+ DIR_X[this.dir]]) {
										this.checkDie(255);
										break;
									}
								}
							}

							if (this.dir != tmpCount) {
								this.count = -3;
								byte tmpCount2;
								if (this.dir == 1 && tmpCount == 2 || this.dir == 0 && tmpCount == 3) {
									tmpCount2 = 48;
								} else if (this.dir == 3 && tmpCount == 2 || this.dir == 0 && tmpCount == 1) {
									tmpCount2 = 56;
								} else if ((this.dir != 2 || tmpCount != 1) && (this.dir != 3 || tmpCount != 0)) {
									tmpCount2 = 72;
								} else {
									tmpCount2 = 64;
								}

								var10000 = map;
								var4 = Map.imgBackground[0].getGraphics();
								var10001 = map;
								GraphicsUtil.drawRegion1(var4, Map.imgBaseBoss[7], tmpCount2, 8, 8, 8, 0,
										mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
								break;
							}

							var10000 = map;
							var4 = Map.imgBackground[0].getGraphics();
							var10001 = map;
							GraphicsUtil.drawRegion1(var4, Map.imgBaseBoss[7], DIR_Y[this.dir] == 0 ? 48 : 56, 0, 8, 8,
									0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
						}
					}
				}
			}
		}

		if (this.isWorldView) {
			this.screenX = map.getScreenX(this.worldX);
			this.screenY = map.getScreenY(this.worldY);
		} else {
			this.worldX = map.getWorldX(this.screenX);
			this.worldY = map.getWorldY(this.screenY);
		}

		this.setCollision();
	}

	public void actExplode() {
		if (this.count > 8) {
			this.worldX += this.worldVX;
			this.worldY += this.worldVY;
			this.worldVY += mcrITOF(6) >> 2;
			if (map.stage % 8 == 7) {
				if (this.worldY > mcrITOF(220)) {
					this.needCheck = false;
				}
			} else if (this.worldY > mcrITOF(184)) {
				ChrCoin.create(this.money, this.worldX, this.worldY, this.worldVX, this.worldVY);
				this.needCheck = false;
			}
		}

	}

	public static void reinitAlien(boolean isDamage) {
		for (int x = 30; x >= 0; --x) {
			for (int y = 24; y >= 0; --y) {
				ALIEN_WAY[y * 31 + x] = x == 0 || x == 30 || y == 0 || y == 24;
			}
		}

		Graphics var10000 = Map.imgBackground[0].getGraphics();
		Map var10001 = map;
		var10000.drawImage(Map.imgLastBackground, 0, 0, 20);
		if (isDamage) {
			chr[level].screenX = mcrITOF(272);
			chr[level].screenY = mcrITOF(88);
			chr[level].worldVX = 0;
			chr[level].worldVY = 0;
			chr[level].dir = 2;
			chr[level].score = 0;
			chr[level].money = 0;
			chr[level].isWorldView = false;
			chr[level].count = 0;
			chr[level].isDead = false;
			chr[level].needCheck = true;
			chr[level].isNoDamage = true;
		}

	}

	public void draw() {
		Map var10000;
		Image var7;
		if (map.stage % 8 == 7) {
			var10000 = map;
			var7 = Map.imgBaseBoss[map.boss];
		} else {
			var10000 = map;
			var7 = Map.imgBaseBoss[1];
		}

		Image img = var7;
		int temp0;
		if (this.type == 0) {
			temp0 = (this.hp - 1) * 5 / this.hpMax;
			if (temp0 > 2) {
				temp0 = 4 - temp0;
			}

			if (this.isNoDamage) {
				this.drawRegion(img, temp0 * 8, 86, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) - 8, 3);
				this.drawRegion(img, temp0 * 8, 86, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) + 0, 3);
				this.drawRegion(img, temp0 * 8, 86, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) + 8, 3);
			} else {
				this.drawRegion(img, temp0 * 8, 86, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) - 9, 3);
				this.drawRegion(img, temp0 * 8, 86, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) + 9, 3);
			}
		}

		if (mcrIsBetween(1, this.type, 20)) {
			if (this.isWorldView) {
				this.drawRegion(img, 16 * ((this.type - 1) % 4), 17 * ((this.type - 1) / 4), 19, 18, 0,
						mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
			} else if (this.type == 1) {
				this.drawRegion(img, 0, 0, 80, 84, 0, mcrFTOI(this.screenX) - 9, mcrFTOI(this.screenY) - 8, 20);
			}
		}

		if (mcrIsBetween(42, this.type, 49)) {
			this.drawRegion(img, 0, 72, 30, 25, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(50, this.type, 57)) {
			this.drawRegion(img, 0, 98 + 19 * (2 - this.hp * 2 / this.hpMax), 21, 19, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(24, this.type, 41)) {
			if (!this.isWorldView || this.count <= 8) {
				int OffsetY = 0;
				int OffsetX = 0;
				if (this.type == 33) {
					OffsetX = 12;
				}

				if (this.type != 24 && this.type != 33) {
					return;
				} else {
					this.drawRegion(img, 0, 0, 30, 71, this.dir == 0 ? 0 : 2, mcrFTOI(this.screenX) - 8 - OffsetX,
							mcrFTOI(this.screenY) - 8, 20);
					return;
				}
			}

			temp0 = (this.type - 24) % 9;
			this.drawRegion(img, BOSS2_TABLE[6 * temp0 + 0], BOSS2_TABLE[6 * temp0 + 1], BOSS2_TABLE[6 * temp0 + 2],
					BOSS2_TABLE[6 * temp0 + 3], this.dir == 0 ? 0 : 2, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(59, this.type, 67)) {
			temp0 = 3 - this.hp * 3 / this.hpMax;
			this.drawRegion(img, 0 + (temp0 / 2 & 1) * 24, 87 + (temp0 & 1) * 8, 24, 8, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(68, this.type, 87)) {
			temp0 = this.type - 68;
			this.drawRegion(img, temp0 % 4 * 16, temp0 / 4 * 17, 16, 18, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if ((this.type == 128 || this.type == 138) && this.count >= 64) {
			temp0 = this.hp > 0 ? 1 - this.hp / this.hpMax : 2;
			this.drawRegion(img, 50 + ANIME_3_LOOP[this.count / 4 % 4] * 32, temp0 * 25, 32, 25, 0,
					mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		int temp1;
		if (mcrIsBetween(89, this.type, 118)) {
			temp0 = (this.type - 89) % 6;
			if (this.dir == 0) {
				temp0 = 5 - temp0;
			}

			temp1 = (this.type - 89) / 6;
			this.drawRegion(img, temp0 * 16, temp1 * 15, 16, 16, this.dir == 2 ? 0 : 2, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(119, this.type, 127) || mcrIsBetween(129, this.type, 137)) {
			temp0 = this.hp > 0 ? 1 - this.hp / this.hpMax : 2;
			this.drawRegion(img, 148, temp0 * 25 + 2, 24, 25, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY) - 2, 3);
		}

		if (mcrIsBetween(140, this.type, 141)) {
			temp0 = 2 - 2 * this.hp / this.hpMax;
			this.drawRegion(img, 58 + (temp0 & 1) * 30, 76 + ((temp0 & 2) >> 1) * 38, 30, 38, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(142, this.type, 145)) {
			temp0 = 2 - 2 * this.hp / this.hpMax;
			this.drawRegion(img, 88 + (temp0 & 1) * 14, 114 + ((temp0 & 2) >> 1) * 18, 14, 18, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(146, this.type, 153)) {
			temp0 = 2 - 2 * this.hp / this.hpMax;
			this.drawRegion(img, 102, 132 + temp0 * 9, 9, 9, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(154, this.type, 173)) {
			temp0 = 2 - 2 * (chr[0].hp + 1) / (chr[0].hpMax + 1);
			temp1 = this.type - 154;
			this.drawRegion(img, (temp0 & 1) * 58 + temp1 % 4 * 14, ((temp0 & 2) >> 1) * 76 + temp1 / 4 * 15, 15, 16, 0,
					mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		if (this.type == 174) {
			this.drawRegion(img, 0, 14 * (3 - this.hp * 3 / this.hpMax), 14, 14, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
			temp0 = (getAngle(this.screenX, this.screenY, chrOpaOpa.screenX, chrOpaOpa.screenY) / 21
					+ (this.count >> 1) % 3 + 11) * 21 % 256;
			this.drawRegion(img, 0, 136, 8, 8, 0, mcrFTOI(this.screenX + mcrFTOI(COS_TABLE[temp0] * mcrITOF(3))),
					mcrFTOI(this.screenY + mcrFTOI(SIN_TABLE[temp0] * mcrITOF(2))) + 1, 3);
			if (this.isNoDamage) {
				temp0 = (this.dir + 5) / 2 - 2;
				if (temp0 < 0) {
					temp0 = -temp0;
				}
			} else {
				temp0 = 3;
			}

			this.drawRegion(img, 14, 14 * temp0, 14, 14, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(175, this.type, 204)) {
			this.drawRegion(img, 0, 56 + 26 * ((this.count >> 1) % 3), 26, 26, 0, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (mcrIsBetween(206, this.type, 235)) {
			temp0 = (this.type - 206) * 6;
			if (chr[0].dir == 1 && (!this.isWorldView || this.count < 8)) {
				if (this.type == 206) {
					this.drawRegion(Map.imgFace[3 - 3 * chr[0].hp / chr[0].hpMax], 0, 0, 200, 100, 0,
							mcrFTOI(this.screenX) - 12, mcrFTOI(this.screenY) - 12, 0);
				}
			} else {
				this.drawRegion(img, BOSS7_TABLE[temp0 + 0],
						BOSS7_TABLE[temp0 + 1] + 106 * (3 - 3 * chr[0].hp / chr[0].hpMax), BOSS7_TABLE[temp0 + 2],
						BOSS7_TABLE[temp0 + 3], this.dir == 2 ? 0 : 2, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
			}
		}

		if (mcrIsBetween(236, this.type, 241)) {
			int[] rot = new int[]{5, 0, 6, 3};
			this.drawRegion1(img, 21, 4, 24, 24, rot[this.dir], mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

	}

	public void drawRegion1(Image img, int sx, int sy, int w, int h, int transform, int tx, int ty, int anchor) {
		GraphicsUtil.drawRegion1(FantasyZone.gcFrame.gc, img, sx, sy, w, h, transform, tx, ty, anchor);
	}

	public void checkDie(int damage) {
		if (!this.isNoDamage) {
			if (this.type == 174) {
				--this.hp;
				this.dir = -5;
				this.isNoDamage = true;
			} else if (this.type == 205) {
				if (damage != 255) {
					this.hp -= damage;
				}
			} else {
				this.hp -= damage;
			}

			if (this.hp <= 0) {
				this.hp = 0;
				this.dead();
			}
		}

	}

	private void dead() {
		this.needCheck = mcrIsBetween(119, this.type, 138);
		chrOpaOpa.addScore(this.score);
		if (mcrIsBetween(59, this.type, 67) && level < 9) {
			++level;
		}

		if (mcrIsBetween(236, this.type, 241)) {
			--level;
			reinitAlien(false);
		}

	}

	static {
		for (int i = 53; i >= 0; --i) {
			chr[i] = new ChrBoss();
		}

	}
}