import javax.microedition.lcdui.Graphics;

public final class ChrEnemyShot extends Chr {
	public static final int CHRENEMYSHOT_PARAM_SPEED = 0;
	public static final int CHRENEMYSHOT_PARAM_X = 1;
	public static final int CHRENEMYSHOT_PARAM_Y = 2;
	public static final int CHRENEMYSHOT_PARAM_WIDTH = 3;
	public static final int CHRENEMYSHOT_PARAM_HEIGHT = 4;
	public static final int CHRENEMYSHOT_PARAM_MAX = 5;
	public static ChrEnemyShot[] chr = new ChrEnemyShot[50];
	public static byte[] PARAM;

	public static void create(int level, int x, int y) {
		if (level >= 0) {
			if (level >= 6) {
				level = 5;
			}

			create(level, x, y, chrOpaOpa.worldX, chrOpaOpa.worldY);
		}
	}

	public static void create(int type, int x1, int y1, int x2, int y2) {
		if (type >= 0) {
			for (int i = 49; i >= 0; --i) {
				if (!chr[i].needCheck) {
					chr[i].reinit(type, x1, y1, x2, y2);
					break;
				}
			}

		}
	}

	public static void clearAll() {
		for (int i = 49; i >= 0; --i) {
			chr[i].needCheck = false;
		}

	}

	public static void actAll() {
		for (int i = 49; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].act();
			}
		}

	}

	public static boolean isHitAll() {
		for (int i = 49; i >= 0; --i) {
			if (chrOpaOpa.isHit(chr[i])) {
				chr[i].needCheck = false;
				return true;
			}
		}

		return false;
	}

	public static void drawAll() {
		for (int i = 49; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].draw();
			}
		}

	}

	public static void drawAllCollision(Graphics gc, int color) {
		for (int i = 49; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].drawCollision(gc, color);
			}
		}

	}

	private void reinit(int type, int x1, int y1, int x2, int y2) {
		int angle = getAngle(map.getScreenX(x1), map.getScreenY(y1), map.getScreenX(x2), map.getScreenY(y2));
		this.worldX = x1;
		this.worldY = y1;
		if (type == 7) {
			this.worldVX = map.getScreenX(x2) - map.getScreenX(x1) >> 4;
			this.worldVY = map.getScreenY(y2) - map.getScreenY(y1) >> 4;
		} else if (type != 6 && type != 7 && type != 9) {
			this.worldVX = COS_TABLE[angle] * PARAM[5 * type + 0];
			this.worldVY = SIN_TABLE[angle] * PARAM[5 * type + 0];
		} else {
			this.worldVX = COS_TABLE[angle] * (PARAM[5 * type + 0] + ChrBoss.level);
			this.worldVY = SIN_TABLE[angle] * (PARAM[5 * type + 0] + ChrBoss.level);
		}

		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.collisionWidth = mcrITOF(1);
		this.collisionHeight = mcrITOF(1);
		this.setCollision();
		this.dir = this.worldVX <= 0 ? 2 : 0;
		this.isWorldView = type < 6;
		this.count = FantasyZone.rnd(4);
		this.needCheck = true;
		this.type = type;
	}

	public void act() {
		++numActive;
		++this.count;
		if (this.type == 6 && (this.dir == 0 || FantasyZone.chrOpaOpa.screenX - this.screenX >= mcrITOF(110))) {
			this.dir = 0;
			if (this.worldVX < 0
					|| mcrSQR(this.worldVX) + mcrSQR(this.worldVY) < mcrSQR(mcrITOF(PARAM[5 * this.type + 0]))) {
				this.worldVX += mcrITOF(PARAM[5 * this.type + 0]) >> 2;
			}
		}

		if (this.type == 7 && this.screenY < mcrITOF(-40)) {
			this.worldVX = 0;
			this.worldVY = mcrITOF(PARAM[5 * this.type + 0]) + (mcrITOF(ChrBoss.level * 3) >> 1);
		}

		if (this.isWorldView) {
			this.worldX += this.worldVX;
			this.worldY += this.worldVY;
			this.screenX = map.getScreenX(this.worldX);
			this.screenY = map.getScreenY(this.worldY);
		} else {
			this.screenX += this.worldVX;
			this.screenY += this.worldVY;
			this.worldX = map.getWorldX(this.screenX);
			this.worldY = map.getWorldY(this.screenY);
		}

		this.setCollision();
		this.needCheck = this.collisionX1 < mcrITOF(244) && this.collisionX2 >= mcrITOF(-4)
				&& this.collisionY1 < mcrITOF(204) && this.collisionY2 >= mcrITOF(-48);
	}

	public void draw() {
		int offset = 5 * this.type;
		int x = (PARAM[offset + 1] & 255) + (this.type == 6 ? PARAM[offset + 3] * (this.count & 3) : 0);
		if (offset == 50) {
			this.drawRegion(FantasyZone.imgSystem[13], 0, 0, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		} else if (offset == 55) {
			this.drawRegion(FantasyZone.imgSystem[13], 8, 0, 8, 8, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		} else if (offset == 60) {
			this.drawRegion(FantasyZone.imgSystem[13], 16, 0, 16, 16, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY),
					3);
		} else if (offset == 65) {
			this.drawRegion(FantasyZone.imgSystem[13], 32, 0, 16, 16, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY),
					3);
		} else {
			this.drawRegion(FantasyZone.imgSystem[18], x, PARAM[offset + 2] & 255, PARAM[offset + 3], PARAM[offset + 4],
					0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

	}

	static {
		for (int i = 49; i >= 0; --i) {
			chr[i] = new ChrEnemyShot();
		}

	}
}