public final class ChrExplode extends Chr {
	public static int[][] ANIME_TABLE = new int[][]{{64, 0, 32, 32, 80, 32, 64, 40, 96, 0, 48, 32},
			{0, 24, 16, 16, 0, 40, 24, 24, 0, 64, 24, 24, 0, 88, 24, 24, 0, 112, 16, 16},
			{48, 80, 16, 24, 48, 64, 8, 16}, {96, 72, 32, 16, 96, 88, 40, 16}, {128, 80, 16, 8, 128, 80, 16, 8},
			{104, 104, 16, 8, 104, 104, 16, 8}, {104, 112, 16, 8, 104, 112, 16, 8}, {104, 120, 16, 8, 104, 120, 16, 8},
			{104, 128, 16, 8, 104, 128, 16, 8}, {120, 104, 24, 8, 120, 104, 24, 8}, {120, 112, 24, 8, 120, 112, 24, 8},
			{120, 120, 24, 8, 120, 120, 24, 8}, {120, 128, 24, 8, 120, 128, 24, 8}};
	public static int[] SE_TABLE = new int[]{0, 3, 7};
	public static ChrExplode[] chr = new ChrExplode[64];

	public static void clearAll() {
		for (int i = 63; i >= 0; --i) {
			chr[i].needCheck = false;
		}

	}

	public static void create(int type, int worldX, int worldY) {
		for (int i = 63; i >= 0; --i) {
			if (!chr[i].needCheck) {
				chr[i].reinit(type, worldX, worldY);
				break;
			}
		}

	}

	public static void actAll() {
		for (int i = 63; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].act();
			}
		}

	}

	public static void drawAll() {
		for (int i = 63; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].draw();
			}
		}

	}

	private void reinit(int type, int worldX, int worldY) {
		this.worldX = worldX;
		this.worldY = worldY;
		this.worldVX = 0;
		this.worldVY = 0;
		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.isWorldView = FantasyZone.chrOpaOpa.isWorldView;
		this.count = 0;
		this.needCheck = true;
		this.type = type;
	}

	public void act() {
		++numActive;
		if (this.count == 0 && this.type < SE_TABLE.length) {
			;
		}

		this.needCheck = this.count++ < ANIME_TABLE[this.type].length >> 1;
		if (this.isWorldView) {
			this.screenX = map.getScreenX(this.worldX);
			this.screenY = map.getScreenY(this.worldY);
		}

	}

	public void draw() {
		if (this.count != 0) {
			int count = this.count - 1 << 1 & -4;
			this.drawRegion(FantasyZone.imgSystem[18], ANIME_TABLE[this.type][count + 0],
					ANIME_TABLE[this.type][count + 1], ANIME_TABLE[this.type][count + 2],
					ANIME_TABLE[this.type][count + 3], 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}
	}

	static {
		for (int i = 63; i >= 0; --i) {
			chr[i] = new ChrExplode();
		}

	}
}