import javax.microedition.lcdui.Graphics;

public final class ChrOpaBomb extends Chr {
	public static final int GU_TRANS_MIRROR = 2;
	public static int[] PARAM = new int[]{mcrITOF(1), mcrITOF(1), 6, mcrITOF(1), mcrITOF(1), 6, mcrITOF(240),
			mcrITOF(0), 0, mcrITOF(240) >> 1, mcrITOF(200), 2, mcrITOF(12), mcrITOF(8), 255, mcrITOF(0), mcrITOF(0), 0,
			mcrITOF(0), mcrITOF(0), 0, mcrITOF(20), mcrITOF(8), 255};
	public static ChrOpaBomb[] chr = new ChrOpaBomb[2];
	public static int numBomb;
	public int damage;

	public static boolean create(int type, int x, int y, int dir) {
		int id = 0;
		if (type == 1) {
			if (numBomb >= 2) {
				return false;
			}
		} else if (type == 2) {
			if (2 - numBomb < 2) {
				return false;
			}
		} else if (numBomb >= 1) {
			return false;
		}

		for (int i = 1; i >= 0; --i) {
			if (!chr[i].needCheck) {
				chr[i].reinit(type, x, y, dir, id);
				if (type != 2 || id == 2) {
					break;
				}

				id = 2;
			}
		}

		return true;
	}

	public static boolean isHitAll() {
		for (int i = 1; i >= 0; --i) {
			ChrOpaBomb chrBomb = chr[i];
			if (chrBomb.needCheck && chrBomb.type != 2) {
				int vector = DIR_X[chr[i].worldVX >= 0 ? 0 : 2];
				Chr chrTarget = null;
				int j;
				if (chrBomb.type != 3 && chrBomb.type != 4 && chrBomb.type != 7) {
					for (j = numEnemyActive - 1; j >= 0; --j) {
						if (chrBomb.isHit(chrEnemyActive[j]) && (chrTarget == null
								|| chrTarget.screenX * vector >= chrEnemyActive[j].screenX * vector)) {
							chrTarget = chrEnemyActive[j];
						}
					}

					if (chrTarget != null) {
						chrTarget.checkDie(chrBomb.damage);
						if (chrBomb.type == 0 || chrBomb.type == 1) {
							chrBomb.type = 5;
						}
					}
				} else {
					for (j = numEnemyActive - 1; j >= 0; --j) {
						if (chrBomb.isHit(chrEnemyActive[j])) {
							chrEnemyActive[j].checkDie(chrBomb.damage);
						}
					}
				}
			}
		}

		return false;
	}

	public static void clearAll() {
		for (int i = 1; i >= 0; --i) {
			chr[i].needCheck = false;
		}

		numBomb = 0;
	}

	public static void actAll() {
		for (int i = 1; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].act();
			}
		}

	}

	public static void drawAll() {
		for (int i = 1; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].draw();
			}
		}

	}

	public static void drawAllCollision(Graphics gc, int color) {
		for (int i = 1; i >= 0; --i) {
			chr[i].drawCollision(gc, color);
		}

	}

	private boolean reinit(int type, int x, int y, int dir, int id) {
		++numBomb;
		this.worldX = x;
		this.worldY = y;
		this.worldVX = 0;
		this.worldVY = 0;
		this.dir = dir;
		this.isWorldView = FantasyZone.chrOpaOpa.isWorldView;
		this.isDead = false;
		this.needCheck = true;
		this.collisionWidth = PARAM[type * 3 + 0];
		this.collisionHeight = PARAM[type * 3 + 1];
		this.type = type;
		this.damage = PARAM[type * 3 + 2];
		switch (type) {
			case 0 :
			case 1 :
				this.worldVY = 0;
				this.worldVX = DIR_X[dir] * mcrITOF(4) + chrOpaOpa.worldVX + (map.boss == 7 ? mcrITOF(4) : 0);
				break;
			case 2 :
				this.worldVY = 0;
				this.worldVX = DIR_X[dir] * mcrITOF(4) + chrOpaOpa.worldVX;
				this.dir = id;
				break;
			case 3 :
				this.isWorldView = false;
				this.screenX = mcrITOF(120);
				this.screenY = mcrITOF(100);
				this.worldX = map.getWorldX(this.screenX);
				this.worldY = map.getWorldY(this.screenY);
				break;
			case 4 :
				this.worldY = -mcrITOF(36);
				this.worldVY = mcrITOF(24);
				this.isWorldView = !map.isLastBoss;
		}

		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		return true;
	}

	public void act() {
		if (this.isDead) {
			--numBomb;
			this.needCheck = false;
		} else {
			switch (this.type) {
				case 0 :
				case 1 :
					this.worldVY += mcrITOF(6) >> 2;
					if (this.worldY >= mcrITOF(192)) {
						this.worldY = mcrITOF(192);
						this.worldVX = 0;
						this.worldVY = 0;
						this.isDead = true;
						ChrExplode.create(3, this.worldX, this.worldY);
					}
					break;
				case 2 :
					this.worldVY += mcrITOF(6) >> 2;
					if (this.worldY >= mcrITOF(180) || this.isExplodeFireBomb()) {
						this.type = 7;
						if (this.worldY >= mcrITOF(180)) {
							this.worldY = mcrITOF(180);
						}

						this.worldVX = mcrITOF(24) * DIR_X[this.dir];
						this.worldVY = 0;
						this.collisionWidth = PARAM[21];
						this.collisionHeight = PARAM[22];
						this.damage = PARAM[23];
					}
					break;
				case 3 :
					this.isDead = true;
					break;
				case 4 :
					this.isDead = this.screenY > mcrITOF(200);
					break;
				case 5 :
					this.type = 6;
					this.worldVX = 0;
					this.worldVY = 0;
					this.collisionWidth = PARAM[15];
					this.collisionHeight = PARAM[16];
					this.damage = PARAM[17];
					this.isDead = true;
				case 6 :
				default :
					break;
				case 7 :
					this.isDead = this.screenX < mcrITOF(-40) || this.screenX > mcrITOF(280);
			}

			if (this.isWorldView) {
				this.worldX += this.worldVX;
				this.worldY += this.worldVY;
				this.screenX = map.getScreenX(this.worldX);
				this.screenY = map.getScreenY(this.worldY);
			} else {
				this.screenX += this.worldVX;
				this.screenY += this.worldVY;
				this.worldX = map.getWorldX(this.screenX);
				this.worldY = map.getWorldY(this.screenY);
			}

			if (this.worldVX >= 0) {
				this.collisionX1 = this.screenX - this.collisionWidth - this.worldVX;
				this.collisionX2 = this.screenX + this.collisionWidth;
			} else {
				this.collisionX1 = this.screenX - this.collisionWidth;
				this.collisionX2 = this.screenX + this.collisionWidth - this.worldVX;
			}

			if (this.worldVY >= 0) {
				this.collisionY1 = this.screenY - this.collisionHeight - this.worldVY;
				this.collisionY2 = this.screenY + this.collisionHeight;
			} else {
				this.collisionY1 = this.screenY - this.collisionHeight;
				this.collisionY2 = this.screenY + this.collisionHeight - this.worldVY;
			}

		}
	}

	private boolean isExplodeFireBomb() {
		for (int i = ChrBase.chr.length - 1; i >= 0; --i) {
			if ((mcrIsBetween(mcrITOF(0), ChrBase.chr[i].collisionX1, mcrITOF(240))
					|| mcrIsBetween(mcrITOF(0), ChrBase.chr[i].collisionX2, mcrITOF(240)))
					&& this.isHit(ChrBase.chr[i])) {
				this.worldY = ChrBase.chr[i].worldY;
				return true;
			}
		}

		return false;
	}

	public void draw() {
		int trans = this.dir == 0 ? 0 : 2;
		if (this.type == 0 || this.type == 1 || this.type == 2) {
			this.drawRegion(FantasyZone.imgSystem[18], 16, 32, 8, 8, trans, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (this.type == 3) {
			FantasyZone.gcFrame.setColor(16777215);
			FantasyZone.gcFrame.fillRect(0, 0, 240, 200);
		}

		if (this.type == 4) {
			this.drawRegion(FantasyZone.imgSystem[18], 56, 32, 24, 16, trans, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (this.type == 5) {
			this.drawRegion(FantasyZone.imgSystem[18], 64, 72, 32, 32, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY),
					3);
		}

		if (this.type == 6) {
			this.drawRegion(FantasyZone.imgSystem[18], 56, 48, 24, 24, 0, mcrFTOI(this.screenX), mcrFTOI(this.screenY),
					3);
		}

		if (this.type == 7) {
			this.drawRegion(FantasyZone.imgSystem[18], 64, 104 + 16 * (FantasyZone.commonCounter & 1), 40, 16, trans,
					mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
		}

	}

	static {
		for (int i = 1; i >= 0; --i) {
			chr[i] = new ChrOpaBomb();
		}

	}
}