import javax.microedition.lcdui.Graphics;

public final class ChrOpaShot extends Chr {
	public static final int GU_TRANS_MIRROR = 2;
	public static int[] PARAM = new int[]{mcrITOF(3), mcrITOF(1), 1, mcrITOF(240), mcrITOF(6), 2, mcrITOF(5),
			mcrITOF(15), 2, mcrITOF(1), mcrITOF(1), 2};
	public static ChrOpaShot[] chr = new ChrOpaShot[35];
	public static int numShot;
	public int damage;

	public static boolean create(int type, int x, int y, int dir, int id) {
		for (int i = 34; i >= 0; --i) {
			if (!chr[i].needCheck) {
				return chr[i].reinit(type, x, y, dir, id);
			}
		}

		return false;
	}

	public static boolean isHitAll() {
		for (int i = 34; i >= 0; --i) {
			if (chr[i].needCheck) {
				ChrOpaShot chrShot = chr[i];
				int vector = DIR_X[chr[i].worldVX >= 0 ? 0 : 2];
				Chr chrTarget = null;

				for (int j = numEnemyActive - 1; j >= 0; --j) {
					if (chrShot.isHit(chrEnemyActive[j]) && (chrTarget == null
							|| chrTarget.screenX * vector >= chrEnemyActive[j].screenX * vector)) {
						chrTarget = chrEnemyActive[j];
					}
				}

				if (chrTarget != null) {
					chrTarget.checkDie(chrShot.damage);
					chrShot.isDead = true;
					if (chrShot.type == 1) {
						if (chrShot.dir == 0) {
							chrShot.collisionX2 = chrTarget.collisionX1;
						} else {
							chrShot.collisionX1 = chrTarget.collisionX2;
						}
					}
				}
			}
		}

		return false;
	}

	public static void clearAll() {
		for (int i = 34; i >= 0; --i) {
			chr[i].needCheck = false;
		}

		numShot = 0;
	}

	public static void actAll() {
		for (int i = 34; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].act();
			}
		}

	}

	public static void drawAll() {
		for (int i = 34; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].draw();
			}
		}

	}

	public static void drawAllCollision(Graphics gc, int color) {
		for (int i = 34; i >= 0; --i) {
			chr[i].drawCollision(gc, color);
		}

	}

	private boolean reinit(int type, int x, int y, int dir, int id) {
		if (numShot == 35) {
			return false;
		} else {
			++numShot;
			this.worldX = x;
			this.worldY = y;
			this.worldVX = 0;
			this.worldVY = 0;
			this.dir = dir;
			this.isWorldView = FantasyZone.chrOpaOpa.isWorldView;
			this.isDead = false;
			this.needCheck = true;
			this.collisionWidth = PARAM[type * 3 + 0];
			this.collisionHeight = PARAM[type * 3 + 1];
			this.type = type;
			this.damage = PARAM[type * 3 + 2];
			switch (type) {
				case 0 :
					this.worldY += id == 0 ? -mcrITOF(3) : mcrITOF(3);
					this.worldVX = DIR_X[dir] * mcrITOF(30);
					break;
				case 1 :
					if (chrOpaOpa.itemNum[4] < 80) {
						this.collisionHeight = mcrITOF(chrOpaOpa.itemNum[4] / 20 + 1);
					}

					this.dir = dir;
					this.worldVX = DIR_X[dir];
					break;
				case 2 :
					this.worldVX = DIR_X[dir] * mcrITOF(30);
					break;
				case 3 :
					int[] arg7way = new int[]{28, 16, 8, 0, 248, 240, 228};
					this.worldVX = DIR_X[dir] * mcrFTOI(COS_TABLE[arg7way[id]] * mcrITOF(30));
					this.worldVY = mcrFTOI(SIN_TABLE[arg7way[id]] * mcrITOF(30));
			}

			this.screenX = map.getScreenX(this.worldX);
			this.screenY = map.getScreenY(this.worldY);
			return true;
		}
	}

	public void act() {
		if (this.isDead) {
			--numShot;
			this.needCheck = false;
		} else if (this.type == 1) {
			this.isDead = true;
			if (this.dir == 0) {
				this.collisionX1 = chrOpaOpa.screenX;
				this.collisionX2 = mcrITOF(240);
			} else {
				this.collisionX1 = 0;
				this.collisionX2 = chrOpaOpa.screenX;
			}

			this.collisionY1 = this.screenY - this.collisionHeight;
			this.collisionY2 = this.screenY + this.collisionHeight;
		} else {
			this.isDead = this.screenX < mcrITOF(-20) || this.screenX > mcrITOF(220) || this.screenY < mcrITOF(-20)
					|| this.screenY > mcrITOF(220);
			if (this.isWorldView) {
				this.worldX += this.worldVX;
				this.worldY += this.worldVY;
				this.screenX = map.getScreenX(this.worldX);
				this.screenY = map.getScreenY(this.worldY);
			} else {
				this.screenX += this.worldVX;
				this.screenY += this.worldVY;
				this.worldX = map.getWorldX(this.screenX);
				this.worldY = map.getWorldY(this.screenY);
			}

			if (this.worldVX >= 0) {
				this.collisionX1 = this.screenX - this.collisionWidth - this.worldVX;
				this.collisionX2 = this.screenX + this.collisionWidth;
			} else {
				this.collisionX1 = this.screenX - this.collisionWidth;
				this.collisionX2 = this.screenX + this.collisionWidth - this.worldVX;
			}

			if (this.worldVY >= 0) {
				this.collisionY1 = this.screenY - this.collisionHeight - this.worldVY;
				this.collisionY2 = this.screenY + this.collisionHeight;
			} else {
				this.collisionY1 = this.screenY - this.collisionHeight;
				this.collisionY2 = this.screenY + this.collisionHeight - this.worldVY;
			}

		}
	}

	public void draw() {
		int trans = this.dir == 0 ? 0 : 2;
		if (this.type == 0) {
			this.drawRegion(FantasyZone.imgSystem[18], 16, 24, 8, 8, trans, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (this.type == 1 && this.collisionX1 < this.collisionX2) {
			FantasyZone.gcFrame.setClip(mcrFTOI(this.collisionX1), mcrFTOI(this.collisionY1),
					mcrFTOI(this.collisionX2 - this.collisionX1), mcrFTOI(this.collisionY2 - this.collisionY1));
			int y = mcrFTOI(this.collisionY2 - this.collisionY1);
			int x;
			if (this.dir == 0) {
				for (x = mcrFTOI(this.collisionX1) - 40
						+ chrOpaOpa.itemNum[4] * 23 % 40; x < mcrFTOI(this.collisionX2); x += 40) {
					this.drawRegion(FantasyZone.imgSystem[18], 24, 0, 40, 16, trans, x, mcrFTOI(this.collisionY1), 20);
				}

				x = mcrFTOI(this.collisionX2);
			} else {
				for (x = mcrFTOI(this.collisionX2)
						- chrOpaOpa.itemNum[4] * 23 % 40; x > mcrFTOI(this.collisionX1); x -= 40) {
					this.drawRegion(FantasyZone.imgSystem[18], 24, 0, 40, y, trans, x, mcrFTOI(this.collisionY1), 24);
				}

				x = mcrFTOI(this.collisionX1);
			}

			FantasyZone.gcFrame.setClip(0, 0, 240, 200);
			if (x != 0 && x != 240) {
				this.drawRegion(FantasyZone.imgSystem[18], 24, 64 + 24 * (chrOpaOpa.itemNum[4] % 3), 24, 24, trans, x,
						mcrFTOI(this.screenY), 3);
			}
		}

		if (this.type == 2) {
			this.drawRegion(FantasyZone.imgSystem[18], 24, 32, 32, 32, trans, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

		if (this.type == 3) {
			this.drawRegion(FantasyZone.imgSystem[18], 16, 112, 8, 8, trans, mcrFTOI(this.screenX),
					mcrFTOI(this.screenY), 3);
		}

	}

	static {
		for (int i = 34; i >= 0; --i) {
			chr[i] = new ChrOpaShot();
		}

		clearAll();
	}
}