import com.nokia.mid.ui.DirectGraphics;
import com.nokia.mid.ui.DirectUtils;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

public final class GraphicsUtil {
	public static final int TRANS_NONE = 0;
	public static final int TRANS_ROT90 = 5;
	public static final int TRANS_ROT180 = 3;
	public static final int TRANS_ROT270 = 6;
	public static final int TRANS_MIRROR = 2;
	public static final int TRANS_MIRROR_ROT90 = 7;
	public static final int TRANS_MIRROR_ROT180 = 1;
	public static final int TRANS_MIRROR_ROT270 = 4;
	private static int keepClipX;
	private static int keepClipY;
	private static int keepClipWidth;
	private static int keepClipHeight;
	private static Sprite tmp;

	public static void drawRegion(Graphics g, Image img, int sx, int sy, int w, int h, int transform, int tx, int ty,
			int anchor) throws NullPointerException, IllegalArgumentException {
		if (img != null) {
			int clipX = FantasyZone.gcFrame.getClipX();
			int clipY = FantasyZone.gcFrame.getClipY();
			int clipWidth = FantasyZone.gcFrame.getClipWidth();
			int clipHeight = FantasyZone.gcFrame.getClipHeight();
			if ((anchor & 1) != 0) {
				tx -= w >> 1;
			} else if ((anchor & 8) != 0) {
				tx -= w;
			}

			if ((anchor & 2) != 0) {
				ty -= h >> 1;
			} else if ((anchor & 32) != 0) {
				ty -= h;
			}

			if (transform == 0) {
				if (tx < clipX) {
					sx += clipX - tx;
					w -= clipX - tx;
					tx = clipX;
				}

				if (tx + w > clipX + clipWidth) {
					w = clipX + clipWidth - tx;
				}

				if (ty < clipY) {
					sy += clipY - ty;
					h -= clipY - ty;
					ty = clipY;
				}

				if (ty + h > clipY + clipHeight) {
					h = clipY + clipHeight - ty;
				}

				if (w <= 0 || h <= 0) {
					return;
				}
			}

			if (transform == 0) {
				FantasyZone.gcFrame.setClip(tx, ty, w, h);
				FantasyZone.gcFrame.drawImage(img, tx - sx, ty - sy, 20);
			} else {
				DirectGraphics dg = DirectUtils.getDirectGraphics(FantasyZone.gcFrame.gc);
				if (ty < 0) {
					FantasyZone.gcFrame.setClip(tx, 18, w, h + ty);
				} else {
					FantasyZone.gcFrame.setClip(tx, ty + 18, w, h);
				}

				if (transform == 2) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty - sy, 20, 8192);
				} else if (transform == 3) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty + sy + h - img.getHeight(), 20, 180);
				} else if (transform == 5) {
					dg.drawImage(img, tx - sy, ty + sx + w - img.getWidth(), 20, 90);
				} else if (transform == 6) {
					dg.drawImage(img, tx + sy + h - img.getHeight(), ty - sx, 20, 270);
				}
			}

			FantasyZone.gcFrame.setClip(clipX, clipY, clipWidth, clipHeight);
		}

	}

	public static void drawRegion0(Graphics g, Image img, int sx, int sy, int w, int h, int transform, int tx, int ty,
			int anchor) throws NullPointerException, IllegalArgumentException {
		if (img != null) {
			int clipX = g.getClipX();
			int clipY = g.getClipY();
			int clipWidth = g.getClipWidth();
			int clipHeight = g.getClipHeight();
			if ((anchor & 1) != 0) {
				tx -= w >> 1;
			} else if ((anchor & 8) != 0) {
				tx -= w;
			}

			if ((anchor & 2) != 0) {
				ty -= h >> 1;
			} else if ((anchor & 32) != 0) {
				ty -= h;
			}

			if (transform == 0) {
				if (tx < clipX) {
					sx += clipX - tx;
					w -= clipX - tx;
					tx = clipX;
				}

				if (tx + w > clipX + clipWidth) {
					w = clipX + clipWidth - tx;
				}

				if (ty < clipY) {
					sy += clipY - ty;
					h -= clipY - ty;
					ty = clipY;
				}

				if (ty + h > clipY + clipHeight) {
					h = clipY + clipHeight - ty;
				}

				if (w <= 0 || h <= 0) {
					return;
				}
			}

			if (transform == 0) {
				g.setClip(tx, ty, w, h);
				g.drawImage(img, tx - sx, ty - sy, 20);
			} else {
				DirectGraphics dg = DirectUtils.getDirectGraphics(g);
				if (ty < 0) {
					g.setClip(tx, 18, w, h + ty);
				} else {
					g.setClip(0, 110, 8, 8);
				}

				if (transform == 2) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty - sy, 20, 8192);
				} else if (transform == 3) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty + sy + h - img.getHeight(), 20, 180);
				} else if (transform == 5) {
					dg.drawImage(img, tx - sy, ty + sx + w - img.getWidth(), 20, 90);
				} else if (transform == 6) {
					dg.drawImage(img, tx + sy + h - img.getHeight(), ty - sx, 20, 270);
				}
			}

			g.setClip(clipX, clipY, clipWidth, clipHeight);
		}

	}

	public static void drawRegion2(Graphics g, Image img, int sx, int sy, int w, int h, int transform, int tx, int ty,
			int anchor) throws NullPointerException, IllegalArgumentException {
		sx = sx * 3 >> 2;
		sy = sy * 3 >> 2;
		w = w * 3 >> 2;
		h = h * 3 >> 2;
		tx = tx * 3 >> 2;
		ty = ty * 3 >> 2;
		if (img != null) {
			int clipX = FantasyZone.gcFrame.gc.getClipX();
			int clipY = FantasyZone.gcFrame.gc.getClipY();
			int clipWidth = FantasyZone.gcFrame.gc.getClipWidth();
			int clipHeight = FantasyZone.gcFrame.gc.getClipHeight();
			if ((anchor & 1) != 0) {
				tx -= w >> 1;
			} else if ((anchor & 8) != 0) {
				tx -= w;
			}

			if ((anchor & 2) != 0) {
				ty -= h >> 1;
			} else if ((anchor & 32) != 0) {
				ty -= h;
			}

			if (transform == 0) {
				if (tx < clipX) {
					sx += clipX - tx;
					w -= clipX - tx;
					tx = clipX;
				}

				if (tx + w > clipX + clipWidth) {
					w = clipX + clipWidth - tx;
				}

				if (ty < clipY) {
					sy += clipY - ty;
					h -= clipY - ty;
					ty = clipY;
				}

				if (ty + h > clipY + clipHeight) {
					h = clipY + clipHeight - ty;
				}

				if (w <= 0 || h <= 0) {
					return;
				}
			}

			if (transform == 0) {
				FantasyZone.gcFrame.gc.setClip(tx, ty, w, h);
				FantasyZone.gcFrame.gc.drawImage(img, tx - sx, ty - sy, 20);
			} else {
				DirectGraphics dg = DirectUtils.getDirectGraphics(FantasyZone.gcFrame.gc);
				if (ty < 0) {
					FantasyZone.gcFrame.gc.setClip(tx, 39, w, h + ty);
				} else {
					FantasyZone.gcFrame.gc.setClip(tx, ty + 39, w, h);
				}

				if (transform == 2) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty - sy, 20, 8192);
				} else if (transform == 3) {
					dg.drawImage(img, tx + sx + w - img.getWidth(), ty + sy + h - img.getHeight(), 20, 180);
				} else if (transform == 5) {
					dg.drawImage(img, tx - sy, ty + sx + w - img.getWidth(), 20, 90);
				} else if (transform == 6) {
					dg.drawImage(img, tx + sy + h - img.getHeight(), ty - sx, 20, 270);
				}
			}

			FantasyZone.gcFrame.gc.setClip(clipX, clipY, clipWidth, clipHeight);
		}

	}

	public static void drawRegion1(Graphics g, Image img, int sx, int sy, int w, int h, int transform, int tx, int ty,
			int anchor) throws NullPointerException, IllegalArgumentException {
		sx = sx * 3 >> 2;
		sy = sy * 3 >> 2;
		w = w * 3 >> 2;
		h = h * 3 >> 2;
		tx = tx * 3 >> 2;
		ty = ty * 3 >> 2;
		if (img != null) {
			int clipX = g.getClipX();
			int clipY = g.getClipY();
			int clipWidth = g.getClipWidth();
			int clipHeight = g.getClipHeight();
			if ((anchor & 1) != 0) {
				tx -= w >> 1;
			} else if ((anchor & 8) != 0) {
				tx -= w;
			}

			if ((anchor & 2) != 0) {
				ty -= h >> 1;
			} else if ((anchor & 32) != 0) {
				ty -= h;
			}

			if (transform == TRANS_NONE) {
				if (tx < clipX) {
					sx += clipX - tx;
					w -= clipX - tx;
					tx = clipX;
				}

				if (tx + w > clipX + clipWidth) {
					w = clipX + clipWidth - tx;
				}

				if (ty < clipY) {
					sy += clipY - ty;
					h -= clipY - ty;
					ty = clipY;
				}

				if (ty + h > clipY + clipHeight) {
					h = clipY + clipHeight - ty;
				}

				if (w <= 0 || h <= 0) {
					return;
				}
			}

			if (ty < 0) {
				g.setClip(tx, 0, w, h + ty);
			} else {
				g.setClip(tx, ty, w, h);
			}

			if (transform == TRANS_NONE) {
				g.drawImage(img, tx - sx, ty - sy, 20);
			} else {
				if (tmp == null) {
					tmp = new Sprite(img);
				} else {
					tmp.setImage(img, img.getWidth(), img.getHeight());
				}

				tmp.setFrame(0);
				if (transform == TRANS_MIRROR) {
					tmp.defineReferencePixel(sx + w, sy);
				} else if (transform == TRANS_ROT180) {
					tmp.defineReferencePixel(sx + w, sy + h);
				} else if (transform == TRANS_MIRROR_ROT180) {
					tmp.defineReferencePixel(sx, sy + h);
				} else if (transform == TRANS_ROT90) {
					tmp.defineReferencePixel(sx, sy + h);
				} else if (transform == TRANS_ROT270) {
					tmp.defineReferencePixel(sx + w, sy);
				} else if (transform == TRANS_MIRROR_ROT90) {
					tmp.defineReferencePixel(sx + w, sy + h);
				} else if (transform == TRANS_MIRROR_ROT270) {
					tmp.defineReferencePixel(sx, sy);
				}

				tmp.setRefPixelPosition(tx, ty);
				tmp.setTransform(transform);
				tmp.paint(g);
			}

			g.setClip(clipX, clipY, clipWidth, clipHeight);
		}

	}

	public static void drawRegionFast(Graphics g, Image img, int sx, int sy, int w, int h, int tx, int ty, int anchor)
			throws NullPointerException, IllegalArgumentException {
		sx = sx * 3 >> 2;
		sy = sy * 3 >> 2;
		w = w * 3 >> 2;
		h = h * 3 >> 2;
		tx = tx * 3 >> 2;
		ty = ty * 3 >> 2;
		if ((anchor & 1) != 0) {
			tx -= w >> 1;
		} else if ((anchor & 8) != 0) {
			tx -= w;
		}

		if ((anchor & 2) != 0) {
			ty -= h >> 1;
		} else if ((anchor & 32) != 0) {
			ty -= h;
		}

		g.setClip(tx, ty, w, h);
		g.drawImage(img, tx - sx, ty - sy, 20);
	}

	public static void drawRegionFast1(Graphics g, Image img, int sx, int sy, int w, int h, int tx, int ty, int anchor)
			throws NullPointerException, IllegalArgumentException {
		if ((anchor & 1) != 0) {
			tx -= w >> 1;
		} else if ((anchor & 8) != 0) {
			tx -= w;
		}

		if ((anchor & 2) != 0) {
			ty -= h >> 1;
		} else if ((anchor & 32) != 0) {
			ty -= h;
		}

		g.setClip(tx, ty, w, h);
		g.drawImage(img, tx - sx, ty - sy, 20);
	}

	public static void lockDrawRegionFast(Graphics g) throws NullPointerException {
		keepClipX = g.getClipX();
		keepClipY = g.getClipY();
		keepClipWidth = g.getClipWidth();
		keepClipHeight = g.getClipHeight();
	}

	public static void unlockDrawRegionFast(Graphics g) throws NullPointerException {
		g.setClip(keepClipX, keepClipY, keepClipWidth, keepClipHeight);
	}
}