import javax.microedition.lcdui.Graphics;

public class ItemSelect {
	public static final int GRAPHICS_LEFT = 4;
	public static final int GRAPHICS_TOP = 16;
	public static final String[] ITEM_TYPE_NAME = new String[3];
	public static final String[] ITEM_NAME = new String[15];
	private static final int[] ITEM_TYPE_ID_OFFSET = new int[]{1, 6, 10};
	private static ItemSelect itemSelect;
	private int windowY;
	private int windowHeight;
	private int menuId;
	private int menuNum;
	private int[] menuTable = new int[16];
	private int[] menuItemTypeId = new int[3];
	private int[] menuEquipTypeId = new int[3];
	private int time;
	public int[] offset = new int[]{1, 6, 10, 0};

	public static ItemSelect getItemSelect() {
		if (itemSelect == null) {
			itemSelect = new ItemSelect();
		}

		return itemSelect;
	}

	public void start(ChrOpaOpa chr) {
		this.menuNum = 0;

		int i;
		for (i = 0; i < this.menuTable.length; ++i) {
			this.menuTable[i] = 0;
		}

		this.menuTable[this.menuNum++] = 0;

		for (i = 0; i < chr.itemNum.length - 1; ++i) {
			if (i == 0) {
				this.menuItemTypeId[0] = this.menuNum;
				this.menuTable[this.menuNum++] = 1;
			} else if (i == 4) {
				this.menuItemTypeId[1] = this.menuNum;
				this.menuTable[this.menuNum++] = 6;
			} else if (i == 7) {
				this.menuItemTypeId[2] = this.menuNum;
				this.menuTable[this.menuNum++] = 10;
			}

			if (chr.itemNum[i] != 0) {
				this.menuTable[this.menuNum++] = ChrOpaOpa.TRANS_SHOPITEM_TO_ITEM[i] + 1;
			}
		}

		for (i = 2; i >= 0; --i) {
			int j;
			for (j = this.menuItemTypeId[i]; chr.equip[i] + ITEM_TYPE_ID_OFFSET[i] != this.menuTable[j]; ++j) {
				;
			}

			if (i == 2) {
				while (this.menuTable[j] > 0) {
					++j;
				}
			} else {
				while (this.menuTable[j] < this.offset[i + 1]) {
					++j;
				}
			}

			chr.equip[i] = this.menuTable[j - 1] - this.offset[i];
			this.menuEquipTypeId[i] = j - 1;
		}

		this.menuId = 0;
		this.time = 20000;
		this.windowHeight = 36 + this.menuNum * 8;
		this.windowY = 158 - this.windowHeight >> 1;
	}

	public boolean act(ChrOpaOpa chr, int key) {
		this.time -= 70;
		if (this.time <= 0) {
			return true;
		} else {
			if ((key & 68640) != 0) {
				if (this.menuId == 0) {
					return true;
				}

				if (this.menuId < this.menuItemTypeId[1]) {
					chr.equip[0] = this.menuTable[this.menuId] - 1;
					this.menuEquipTypeId[0] = this.menuId;
				} else if (this.menuId < this.menuItemTypeId[2]) {
					chr.equip[1] = this.menuTable[this.menuId] - 6;
					this.menuEquipTypeId[1] = this.menuId;
				} else {
					chr.equip[2] = this.menuTable[this.menuId] - 10;
					this.menuEquipTypeId[2] = this.menuId;
				}

				FantasyZone.repaintItem = true;
			}

			if ((key & '脀') != 0) {
				++this.menuId;
			}

			if ((key & 4100) != 0) {
				this.menuId += this.menuNum - 1;
			}

			this.menuId %= this.menuNum;
			return false;
		}
	}

	public void draw(Graphics gc) {
		gc.translate(8, this.windowY);
		FantasyZone.drawStatusFrame(0, 0, 160, this.windowHeight);
		FantasyZone.drawEnglish(4, "PARTS SELECT", 50, 5);

		int i;
		for (i = ITEM_TYPE_NAME.length - 1; i >= 0; --i) {
			;
		}

		for (i = this.menuNum - 1; i >= 0; --i) {
			FantasyZone.drawEnglish0(0, ITEM_NAME[this.menuTable[i]], 52, 20 + 8 * i);
		}

		FantasyZone.drawEnglish0(0, "'", 36, 20 + 8 * this.menuId);

		for (i = this.menuItemTypeId.length - 1; i >= 0; --i) {
			FantasyZone.drawEnglish0(4, "*", 44, 20 + 8 * this.menuEquipTypeId[i]);
		}

		FantasyZone.drawEnglish0(0, FantasyZone.getString(116) + this.time / 1000, 115, 15);
		gc.translate(-8, -this.windowY);
	}
}