import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

public final class Map {
	public static int nextLoadCount;
	public static final int FIXED_POINT = 12;
	public static final int GRAPHICS_HCENTER = 1;
	public static final int GRAPHICS_VCENTER = 2;
	public static final int GRAPHICS_LEFT = 4;
	public static final int GRAPHICS_RIGHT = 8;
	public static final int GRAPHICS_TOP = 16;
	public static final int GRAPHICS_BOTTOM = 32;
	public static final int SPD_OPAOPA_MINIMUM = mcrITOF(2);
	public static final int[][] MAP_ENEMY_LOAD_PARAM = new int[7][];
	public int stage;
	public int stageCount;
	public int boss;
	public int bossCounter;
	public int enemyCounter;
	public int enemyPointer;
	public boolean isShopCalled;
	public boolean isBoss;
	public boolean isLastBoss;
	public boolean isRoundUp;
	public int thisLoadCount;
	public static Image[] imgBackground;
	public static Image imgLastBackground;
	public static Sprite[] sprForeground;
	public static Image[] simgForeground;
	public static Image[] imgBaseBoss;
	public static Image[] imgFace;
	public int cameraX;
	public int cameraVX;
	public boolean isCameraFollowOpaOpa;

	public static int mcrITOF(int x) {
		return x << 12;
	}

	public static int mcrFTOI(int x) {
		return x >> 12;
	}

	public static boolean mcrIsBetween(int a, int x, int b) {
		return a <= x && x <= b;
	}

	public static int mcrSQR(int x) {
		return x * x;
	}

	public void init() {
		this.stageCount = 0;
		this.enemyCounter = 0;
		this.enemyPointer = 0;
		this.boss = this.stage % 8 % 7;
		this.reinit();
	}

	public void reinit() {
		this.cameraX = mcrITOF(2048) - (mcrITOF(240) >> 1);
		this.cameraVX = 0;
		this.bossCounter = 0;
		this.isShopCalled = false;
		this.isBoss = false;
		this.isLastBoss = false;
		this.isRoundUp = false;
	}

	public boolean loadBG(int stage) {
		if (this.stage % 8 != stage % 8) {
			this.stage = stage;
			this.thisLoadCount = 0;
		}

		Thread var10000;
		stage %= 8;
		nextLoadCount = this.thisLoadCount + 1;
		int i;
		label237 : switch (this.thisLoadCount) {
			case 0 :
				imgBackground = null;
				imgLastBackground = null;
				simgForeground = null;
				sprForeground = null;
				Shop.img = null;
				ChrEnemy.imgEnemy = null;
				ChrOpaOpa.imgOpaOpa = null;
				FantasyZone.imgSystem = null;
				break;
			case 1 :
				simgForeground = new Image[2];
				sprForeground = new Sprite[2];
				imgFace = new Image[4];
				break;
			case 2 :
				FantasyZone.fileOpen(FantasyZone.strageJarInflater(2 + stage * 2));
				simgForeground[0] = FantasyZone.loadImage();
				byte[] buf0 = null;
				simgForeground[1] = FantasyZone.loadImage();
				Object var4 = null;

				try {
					for (i = 0; i < 4; ++i) {
						imgFace[i] = Image.createImage("/face_" + i + ".png");
					}
				} catch (Exception var12) {
					;
				}

				if (simgForeground[0] == null || simgForeground[1] == null) {
					nextLoadCount = 1;
				}

				if (!FantasyZone.fileClose()) {
					nextLoadCount = 1;
				}
				break;
			case 3 :
				sprForeground[0] = new Sprite(simgForeground[0], 256, simgForeground[0].getHeight());
				sprForeground[1] = new Sprite(simgForeground[1], 256, simgForeground[1].getHeight());
				break;
			case 4 :
				ChrOpaOpa.imgOpaOpa = new Image[2];
				imgBaseBoss = new Image[stage == 7 ? 11 : 2];
				break;
			case 5 :
				FantasyZone.fileOpen(FantasyZone.strageJarInflater(0));

				for (i = 0; i < 2; ++i) {
					try {
						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
					} catch (Exception var11) {
						;
					}

					ChrOpaOpa.imgOpaOpa[i] = FantasyZone.loadImage();
					if (ChrOpaOpa.imgOpaOpa[i] == null) {
						nextLoadCount = 4;
						break;
					}
				}

				if (stage == 7) {
					for (i = 0; i < 11; ++i) {
						try {
							var10000 = FantasyZone.thread;
							Thread.sleep(100L);
						} catch (Exception var10) {
							;
						}

						FantasyZone.skipResource(i < 7 ? 1 : 0);
						imgBaseBoss[i] = FantasyZone.loadImage();
					}
				} else {
					FantasyZone.skipResource(stage * 2);
					imgBaseBoss[0] = FantasyZone.loadImage();
					imgBaseBoss[1] = FantasyZone.loadImage();
					if (imgBaseBoss[0] == null || imgBaseBoss[1] == null) {
						nextLoadCount = 4;
						break;
					}
				}

				if (!FantasyZone.fileClose()) {
					nextLoadCount = 4;
				}
				break;
			case 6 :
				Shop.img = new Image[5];
				break;
			case 7 :
				FantasyZone.fileOpen(4);

				for (i = 0; i < 5; ++i) {
					try {
						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
					} catch (Exception var9) {
						;
					}

					Shop.img[i] = FantasyZone.loadImage();
					if (Shop.img[i] == null) {
						nextLoadCount = 6;
						break;
					}
				}

				if (!FantasyZone.fileClose()) {
					nextLoadCount = 6;
				}
				break;
			case 8 :
				imgBackground = new Image[4];
				break;
			case 9 :
				if (stage == 7) {
					imgBackground[0] = Image.createImage(240, 200);
					if (imgBackground[0] == null) {
						nextLoadCount = 8;
					}

					FantasyZone.fileOpen(FantasyZone.strageJarInflater(1 + stage * 2));
					imgLastBackground = FantasyZone.loadImage();
				} else {
					FantasyZone.fileOpen(FantasyZone.strageJarInflater(1 + stage * 2));
					imgBackground[0] = FantasyZone.loadImage();
					imgBackground[1] = FantasyZone.loadImage();
					imgBackground[2] = FantasyZone.loadImage();
					imgBackground[3] = FantasyZone.loadImage();

					for (i = 0; i < 4; ++i) {
						if (imgBackground[i] == null) {
							nextLoadCount = 8;
							break;
						}
					}

					if (!FantasyZone.fileClose()) {
						nextLoadCount = 8;
					}
				}
				break;
			case 10 :
				ChrEnemy.imgEnemy = new Image[24];
				break;
			case 11 :
				FantasyZone.fileOpen(5);

				for (i = 0; i < 16; ++i) {
					try {
						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
					} catch (Exception var8) {
						;
					}

					ChrEnemy.imgEnemy[i] = FantasyZone.loadImage();
					if (ChrEnemy.imgEnemy[i] == null) {
						nextLoadCount = 10;
						break;
					}
				}
			case 12 :
				break;
			case 13 :
				for (i = 16; i < 24; ++i) {
					try {
						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
					} catch (Exception var7) {
						;
					}

					ChrEnemy.imgEnemy[i] = FantasyZone.loadImage();
					if (ChrEnemy.imgEnemy[i] == null) {
						nextLoadCount = 10;
						break;
					}
				}

				if (!FantasyZone.fileClose()) {
					nextLoadCount = 10;
				}
				break;
			case 14 :
				FantasyZone.imgSystem = new Image[19];
				break;
			case 15 :
				try {
					FantasyZone.fileOpen(1);
					i = 0;

					while (true) {
						if (i >= 13) {
							break label237;
						}

						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
						FantasyZone.imgSystem[i] = FantasyZone.loadImage();
						if (FantasyZone.imgSystem[i] == null) {
							nextLoadCount = 14;
							break label237;
						}

						++i;
					}
				} catch (Exception var14) {
					break;
				}
			case 16 :
				try {
					for (i = 13; i < 19; ++i) {
						var10000 = FantasyZone.thread;
						Thread.sleep(100L);
						FantasyZone.imgSystem[i] = FantasyZone.loadImage();
						if (FantasyZone.imgSystem[i] == null) {
							nextLoadCount = 14;
							break;
						}
					}

					if (!FantasyZone.fileClose()) {
						nextLoadCount = 14;
					}
				} catch (Exception var13) {
					;
				}
				break;
			default :
				if (stage == 7) {
					this.isBoss = true;
				}

				ChrBase.create(this.stage);
				return true;
		}

		this.thisLoadCount = nextLoadCount;
		System.gc();

		try {
			var10000 = FantasyZone.thread;
			Thread.sleep(100L);
		} catch (Exception var6) {
			;
		}

		return false;
	}

	public void drawBackground() {
		int x = mcrFTOI(this.cameraX);
		int view;
		int offsetX;
		if (this.stage % 8 == 7) {
			if (this.isLastBoss) {
				FantasyZone.gcFrame.drawImage(imgBackground[0], 0, 0, 20);
			}
		} else {
			view = (x >> 1) / 256;
			offsetX = (x >> 1) % 256;
			FantasyZone.gcFrame.drawImage(imgBackground[view + 0 & 3], -offsetX + 0, 0, 20);
			FantasyZone.gcFrame.drawImage(imgBackground[view + 1 & 3], -offsetX + 256, 0, 20);
		}

		if (this.stage != 1 && !this.isLastBoss) {
			view = x / 256;
			offsetX = x % 256;
			view = x / 1024;
			offsetX = x % 1024;
			FantasyZone.gcFrame.drawImage(simgForeground[view + 0 & 1], -offsetX + 0, 200, 36);
			FantasyZone.gcFrame.drawImage(simgForeground[view + 1 & 1], -offsetX + 1024, 200, 36);
		}

	}

	public void drawForeground() {
		int x = mcrFTOI(this.cameraX);
		if (this.stage % 8 == 1) {
			int view = x / 1024;
			int offsetX = x % 1024;
			FantasyZone.gcFrame.drawImage(simgForeground[view + 0 & 1], -offsetX + 0, 200, 36);
			FantasyZone.gcFrame.drawImage(simgForeground[view + 1 & 1], -offsetX + 1024, 200, 36);
		}

	}

	public int getScreenX(int worldX) {
		int value = (mcrITOF(2048) + worldX - this.cameraX) % mcrITOF(2048);
		return value >= mcrITOF(2048) >> 1 ? value - mcrITOF(2048) : value;
	}

	public int getScreenY(int worldY) {
		return worldY;
	}

	public int getWorldX(int screenX) {
		return (mcrITOF(2048) + this.cameraX + screenX) % mcrITOF(2048);
	}

	public int getWorldY(int screenY) {
		return screenY;
	}

	public void setView(ChrOpaOpa chr, boolean force) {
		int vxDir = Chr.DIR_X[chr.dir];
		if (force) {
			this.isCameraFollowOpaOpa = false;
			this.cameraVX += mcrITOF(1) >> 1;
			if (this.cameraVX >= mcrITOF(3)) {
				this.cameraVX = mcrITOF(3);
			}

			this.cameraX = (mcrITOF(2048) + this.cameraX + this.cameraVX) % mcrITOF(2048);
		} else {
			int screenX;
			if (this.isCameraFollowOpaOpa && chr.isMove && vxDir * this.cameraVX > 0) {
				this.cameraVX = vxDir * (ChrOpaOpa.SPD_OPAOPA[chr.equip[0]] + mcrITOF(3));
				this.cameraX = (mcrITOF(2048) + this.cameraX + this.cameraVX) % mcrITOF(2048);
				screenX = this.getScreenX(chr.worldX);
				if (vxDir > 0) {
					if (screenX <= mcrITOF(70)) {
						this.cameraX = (mcrITOF(2048) + this.cameraX - (mcrITOF(70) - screenX)) % mcrITOF(2048);
					}
				} else if (screenX >= mcrITOF(106)) {
					this.cameraX = (mcrITOF(2048) + this.cameraX - (mcrITOF(106) - screenX)) % mcrITOF(2048);
				}
			} else {
				this.isCameraFollowOpaOpa = false;
				if (vxDir * this.cameraVX < 0) {
					this.cameraVX = vxDir * (SPD_OPAOPA_MINIMUM * 10 >> 3);
				} else {
					this.cameraVX += vxDir * (SPD_OPAOPA_MINIMUM * 10 >> 5);
					if (this.cameraVX * vxDir >= SPD_OPAOPA_MINIMUM * 10 >> 3) {
						this.cameraVX = vxDir * (SPD_OPAOPA_MINIMUM * 10 >> 3);
					}
				}

				this.cameraX = (mcrITOF(2048) + this.cameraX + this.cameraVX) % mcrITOF(2048);
				screenX = this.getScreenX(chr.worldX);
				if (screenX <= mcrITOF(90)) {
					if (vxDir < 0) {
						if (chr.isMove) {
							this.isCameraFollowOpaOpa = true;
							this.cameraVX = vxDir;
						}
					} else if (screenX >= mcrITOF(90) - (SPD_OPAOPA_MINIMUM * 10 >> 3)) {
						this.cameraX = (mcrITOF(2048) + this.cameraX - (mcrITOF(90) - screenX)) % mcrITOF(2048);
					} else if (chr.isEarth) {
						this.cameraX = (mcrITOF(2048) + this.cameraX - ((SPD_OPAOPA_MINIMUM * 10 >> 3) * 3 >> 1))
								% mcrITOF(2048);
					} else {
						this.cameraX = (mcrITOF(2048) + this.cameraX - (SPD_OPAOPA_MINIMUM * 10 >> 3 >> 1))
								% mcrITOF(2048);
					}
				}

				if (screenX >= mcrITOF(150)) {
					if (vxDir > 0) {
						if (chr.isMove) {
							this.isCameraFollowOpaOpa = true;
							this.cameraVX = vxDir;
						}
					} else if (screenX <= mcrITOF(150) + (SPD_OPAOPA_MINIMUM * 10 >> 3)) {
						this.cameraX = (mcrITOF(2048) + this.cameraX - (mcrITOF(150) - screenX)) % mcrITOF(2048);
					} else if (chr.isEarth) {
						this.cameraX = (mcrITOF(2048) + this.cameraX + ((SPD_OPAOPA_MINIMUM * 10 >> 3) * 3 >> 1))
								% mcrITOF(2048);
					} else {
						this.cameraX = (mcrITOF(2048) + this.cameraX + (SPD_OPAOPA_MINIMUM * 10 >> 3 >> 1))
								% mcrITOF(2048);
					}
				}
			}

			if (screenX < mcrITOF(20)) {
				this.cameraX = (mcrITOF(2048) + chr.worldX - mcrITOF(20)) % mcrITOF(2048);
			}

			if (screenX > mcrITOF(220)) {
				this.cameraX = (mcrITOF(2048) + chr.worldX - mcrITOF(220)) % mcrITOF(2048);
			}
		}

		++this.stageCount;
	}

	public void appearEnemy() {
		if (!this.isBoss) {
			int[] LOAD = MAP_ENEMY_LOAD_PARAM[this.stage % 8];
			if (!this.isShopCalled && FantasyZone.chrOpaOpa.money >= 2000 && FantasyZone.chrOpaOpa.equip[1] == 0) {
				ChrBalloon.create(true, FantasyZone.chrOpaOpa.dir);
				this.isShopCalled = true;
			}

			++this.enemyCounter;

			while (LOAD[7 * this.enemyPointer + 0] == this.enemyCounter) {
				int pointer = 7 * this.enemyPointer;
				ChrEnemy.create(LOAD[pointer + 1], LOAD[pointer + 2], LOAD[pointer + 3] + this.stage / 8,
						this.getWorldX(mcrITOF(LOAD[pointer + 4])), this.getWorldY(mcrITOF(LOAD[pointer + 5])),
						LOAD[pointer + 6]);
				++this.enemyPointer;
			}

			if (LOAD[7 * this.enemyPointer + 0] <= 0) {
				this.enemyCounter = -LOAD[7 * this.enemyPointer + 0];
				this.enemyPointer -= LOAD[7 * this.enemyPointer + 1];
			}

		}
	}

	public boolean enterBossBattle() {
		if (this.stage % 8 != 7 && ++this.bossCounter != 50) {
			return false;
		} else {
			this.isBoss = true;
			FantasyZone.chrOpaOpa.isWorldView = false;
			ChrBoss.clearAll();
			ChrBoss.create(this.boss, this.stage);
			return true;
		}
	}

	public boolean isBeatBoss() {
		if (!this.isBoss) {
			return false;
		} else {
			this.isRoundUp = !ChrBoss.chr[0].needCheck;
			if (this.stage % 8 != 7) {
				FantasyZone.chrOpaOpa.isWorldView = this.isRoundUp;
			}

			return this.isRoundUp;
		}
	}
}